//функции для зарплаты
include("Objects/DpCalendar.js");
include("Objects/DpClEx.js");
include("servis/date.js");
include("sys/dbase.js");
include("servis/cdr.js");
include("prik/DpPrik.js");
include("prik/calculate/r_vsp_f.js");
include("sys/udfs.js");
include("prik/calculate/r_mnvk.js");
include("get_const.js");

//Расчёт подоходного налога
function Podox_nal(sum_baz, dat)
{
	//sum_baz Сумма по которой ищем строку подоходного налога
	var sum_baz=round(sum_baz,2);
	var mdat1=dat?firstDayMonth(dat):getPar("GLOBDAT1");
	var mdat2=dat?lastDayMonth(dat):getPar("GLOBDAT2");
	StrSQL="SELECT * FROM ^NALOG "
		+" where Fbdat<="+sqlTo(mdat2)+" AND Fedat>="+sqlTo(mdat1)
		+" ORDER BY F_STSUM DESC";
	var tpd=OpenTable(StrSQL);
	var sum_ogr = get_cnst("sum_ogr",mdat2);
	var esv_proc = getEsvProc('-','z',mdat2);
	var i=0;
    for (tpd.MoveFirst();!tpd.IsEOF();tpd.MoveNext())
    {
		if (sum_baz>=Number(tpd.getValue("F_STSUM")))
		{
			i=round((sum_baz-tpd.getValue("F_STSUM")-(sum_baz>sum_ogr?(sum_ogr-tpd.getValue("F_STSUM")):(sum_baz-tpd.getValue("F_STSUM")))*esv_proc/100)*tpd.getValue("F_PROC")/100+(Number(tpd.getValue("F_STSUM"))-tpd.getValue("F_STSUM")*esv_proc/100)*0.15,2);
			break;
		}
	}
	tpd.close();
	return i;
}

//Вычисляет АЛИМЕНТЫ
function Alim(tabn,mFbdat,sum)
{
	var t_alim=OpenTable("SELECT p.FPROC,a.Fsbor FROM ^prk_all as p INNER JOIN ^prk_al AS a ON p.Fwid=a.Fwid "
			+" WHERE p.Ftabn_id="+tabn+" AND p.Fbdat<="+sqlTo(mFbdat)+" AND p.Fedat>="+sqlTo(mFbdat))
	var ret = 0;
	for(; !t_alim.IsEOF(); t_alim.MoveNext())
		ret += sum*t_alim.getValue("Fproc")/100+Number(t_alim.getValue("Fsbor"));
	t_alim.close();
	return ret;
}

//вычисляет плановую сумму удержания ссуды
function getSumSsuda(tabn_id,dat)
{
	var tbl = OpenTable("select * from ^prk_all where Ftabn_id="+tabn_id+" and Fbdat<="+sqlTo(dat)+" and Fdat_prik>="+sqlTo(dat)+" and Fin_table="+sqlTo("PRK_SU")+" and Fnom_prik<>"+sqlTo("0"));
	var ret = 0;
	for(; !tbl.IsEOF(); tbl.MoveNext())
		ret += Number(tbl.getValue("Fproc"));
	tbl.close();
	return ret;
}

function writeToLog(txt,type,fvopl,fvid_prk,flsfid)
{
	var fid = Number(ReadParEx("FWID_RUNZRP"));
	if(fid == 0)
	{
		WAIT(ru("Запись не может быть добавлена в лог зарплаты!","Запис не може бути добавлений в лог зарплати!"))
		return false;
	}
	var m = new Object();
	m.Fid = fid;
	m.Ftxt = txt;
	m.Ftype = type;
	m.Fvopl = fvopl;
	m.Fvid_prk = fvid_prk;
	m.Flsfid = flsfid;
	b = UpdateTable("^logzrp", m, true, null, null, false);
	if(!b)
		WAIT(ru("Ошибка записи в лог зарплаты!","Помилка запису в лог зарплати!"));
}

//делает проверку на коректность категорий в ШР
function isCorectKat(isSielent,dat)
{
    var sWhere = "";
    if(dat)
    {
    	var bdat = firstDayMonth(dat);
    	var edat = lastDayMonth(dat);
    	sWhere = " and w.Fbdat<="+sqlTo(edat)+" and w.Fedat>="+sqlTo(bdat);
    }
    strSQL = "select l.Fcod as Tabn, l.Ftxt as Fio, w.Fbdat as Fbdat from ^work_pers as w inner join ^listcl as l on w.Fwid_cl=l.Fwid_cl "
    				+" where 1=1"
						+" and (w.Fwid_kat=0 or w.Fwid_kat is null)"
						+" and l.FCL = "+sqlTo(getPar("CODPERS"))
						+sWhere
    				+" order by l.Fcod"
    var t = OpenTable(strSQL);
    if(!t.IsEmpty())
    {
    	if(!isSielent)
    	{
	    	browse(strSQL)
	    	alert(ru("В штатном расписании найдены записи с непроставленными кодами категорий в количестве = "+t.rowCount+"\nРасчет не может быть выполнен.",
	    			"В штатному розкладі знайдені записи з відсутніми кодами категорій в кількості = "+t.rowCount+"\nРозрахунок не може бути виконан."));
    	}
    	t.close();
    	return false;
    }
    t.close();
    return true;
}

//в эту функцию можно добавлять различные проверки при сохранении записей в ШР
function canSaveShtat(mode,fwid_wp,fwid_cl,bdat)
{
	switch(mode.toUpperCase())
	{
		case "NEW":
			//обрабатываем ситуацию, когда дата начала выпадает на первое число, а у сотрудника уже сформирован табель на этот месяц
			if(bdat.getDate()==1)
			{
				var snap = getSnap("select * from ^tbl"+getDateTag(bdat)+" where Fwid_wp="+fwid_wp,false);
				if(snap && !confirm(ru("Табель за "+format("Mmm yyyy",bdat).toLowerCase()+" по таб.№"+getCodFromID(fwid_cl)+" будет удален.\nОтработанное время при последующем переформировании табелей не восстановится!\nПродолжить сохранение?",
									"Табель за "+format("Mmm yyyy",bdat).toLowerCase()+" по таб.№"+getCodFromID(fwid_cl)+" буде видалено.\nВідпрацьований час при подальшому переформовуванні табелів не відновиться!\nПродовжити збереження?")))
					return false;
			}
		break;
	}
	return true;
}

function getWorkDays(calend,bdat,edat)
{
	oCal = new dpCalendar();
	oCal.setCod(calend);
	return oCal.getCalDays("Р",bdat,edat);
}

function getWorkHours(calend,bdat,edat)
{
	oCal = new dpCalendar();
	oCal.setCod(calend);
	return oCal.getCalHours("Р",bdat,edat);
}

function getDaysOtp(calend,bdat,edat)
{
	bdat = new Date(bdat);
	edat = new Date(edat);
	oCal = new dpCalendar();
	oCal.setCod(calend);
	diff = day_difference(bdat,edat);
	prazn = oCal.getCalDays("П",bdat,edat);
	return diff - prazn;
}

//перезаписываем приказы зависящие от оклада (PRK2,PRK3,PRK4) на новый код ШР,
//edat - дата на день раньше bdat  
function overWritePrik(old_fwid_wp,new_fwid_wp,bdat,edat,isSilent,fwid_prk,ignorTypePrk)
{
	bdat = new Date(bdat);
	if(edat == null)
		edat = new Date(goDay(bdat,-1));
	//если таб.№ ведутся в разрезе подразделений, тогда нужно перезаписывать все приказы при переводе, чтоб видеть в них новые таб.№ 
	//но только если они не имеют даты окончания и перезаписывается на первое число
	if(getPar("TABNORG"))
	{
		if(bdat.getDate()==1)
			var sWhere = " AND (p.Fedat="+sqlTo(d00)+(ignorTypePrk?" OR 1=1":" OR p.Fin_table in ('PRK2','PRK3','PRK4')")+")";
		else
			var sWhere = ignorTypePrk?" AND 1=1 ":" AND p.Fin_table in ('PRK2','PRK3','PRK4')";
	}
	else
		var sWhere = ignorTypePrk?" AND 1=1 ":" AND p.Fin_table in ('PRK2','PRK3','PRK4')";
	if(fwid_prk)
		sWhere += " AND p.Fwid = "+fwid_prk;
	var tbn = OpenTable("SELECT p.*, p4.Fwid_wp2, p4.Ftabn_id2, cl.Fedit "
				+" FROM ^prk_all AS p "
					+" LEFT JOIN ^prk4 AS p4 ON p.Fwid=p4.Fwid "
					+" INNER JOIN ^cl_prik as cl ON cl.Fvid=p.Fvid_prk"
			+" WHERE p.Fwid_wp="+sqlTo(old_fwid_wp)
				+sWhere
				+" AND p.Fbdat < " + sqlTo(bdat)
				+" AND p.Fedat >= " + sqlTo(bdat)
			+" ORDER BY p.Fvid_prk, p.Fbdat, p.Fedat");
	if (!tbn.IsEmpty())
	{
		var k = 0;
		for(tbn.MoveFirst(); !tbn.IsEOF(); tbn.MoveNext())
		{
			//если по какой-то причине в приказе не проставлен Ftabn_id, то проставим
			if(tbn.getValue("Ftabn_id")==null || tbn.getValue("Ftabn_id")==0)
			{
				var tabn = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+sqlTo(tbn.getValue("Fwid_wp")));
				if(tabn!=null)
					ExecuteSQL("UPDATE ^prk_all SET Ftabn_id="+sqlTo(tabn[0])+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
			}
			//если коды записей не совпадают, значит добавляем запись в приказ
			if(new_fwid_wp!=tbn.getValue("Fwid_wp") || fwid_prk)//по конкретному приказу перезаписываем в любом случае, как было раньше при перезаписи из списка приказов
			{
				var snap = getSnap("select Fnum, Fnazv from ^cl_prik where Fvid="+sqlTo(tbn.getValue("FVID_PRK")))
				if(snap!=null)
					WAIT(UR("Перезапис наказу №|Перезапись приказа №")+snap[0]+"("+tbn.getValue("FVID_PRK")+") "+UR(snap[1]));
				if(tbn.getValue("FWID_WP2")>0)
				{
					alert(UR("Наказ №|Приказ №")+snap[0]+"("+tbn.getValue("FVID_PRK")+") "+UR(snap[1])+"\nНа таб.№"
							+getCodFromID(tbn.getValue("Ftabn_id"))+UR(", дата початку |, дата начала ")+format("dd.mm.yyyy",tbn.getValue("Fbdat"))
							+UR(" необхідно буде перезаписати в ручному режимі!| необходимо будет перезаписать в ручном режиме!"));
					continue;
				}
				//перезапись переделал на объекты, т.к. в случае с ведением таб.номеров по подразделениям, могут перезаписываться приказы,
				//которые хранятся в нескольких таблицах, да и для истории это будет правильней, хотя и медленее
//				m = scatter(tbn);
//				m.FWID = GetUID();
//				m.FBDAT = bdat;
//				m.FWID_WP = new_fwid_wp;
//				//для приказов замещения (_PRK55), важен оклад замещаемого человека, поэтому его будем перезаписывать тоже
//				//а относящиеся к нему поля удалим из объекта m для выполнения коректной вставки записи в таблицу PRK_ALL
//				delete m.FWID_WP2;
//				delete m.FTABN_ID2;
//				UpdateTable("^prk_all", m, true);
//				//закрываем дату старого приказа
//				ExecuteSQL("UPDATE ^prk_all SET Fedat="+sqlTo(edat)+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
				var prkLbl = allt(tbn.getValue("Fedit")).toUpperCase();
				if(!prkLbl)
					continue;
				var oPrik = new DpPrik(prkLbl, tbn.getValue("Fvid_prk"));
				oPrik.loadByID(tbn.getValue("Fwid"));
				var bufedat = oPrik.getVar("FEDAT");
				//закрываем старый
				oPrik.setVar("FEDAT", new Date(edat).getVarDate());
				oPrik.save();
				//создаем приказ с новым кодом ШР
				oPrik.clone();
				oPrik.setVar("FBDAT", new Date(bdat).getVarDate());
				oPrik.setVar("FEDAT", bufedat);
				oPrik.setVar("FWID_WP", new_fwid_wp);
				//обрабатываем приказы на замещение других сотрудников
				if(oPrik.getVar("FWID_WP2") > 0)
				{
					//добавлеям в приказ за замещение оклада
					snap = getSnap("select MAX(Fwid) from ^work_pers where Fwid_cl="+oPrik.getVar("FTABN_ID2")
									+" and Fbdat<="+sqlTo(bdat)+" and Fedat>="+sqlTo(bdat));//в этом случае дата начала может и в большенстве случаев будет совпадать с bdat 
					if(snap[0]>0)
						oPrik.setVar("FWID_WP", snap[0]);
				}
				oPrik.save();
				k++;
			}
		}
		s = ru("Кол-во перезаписанных приказов на новый код штатного расписания: "+k,
				"Кількість перезаписаних наказів на новий код штатного розкладу: "+k)
		if(isSilent)
			WAIT(s);
		else
			alert(s);
	}
	else
		WAIT(UR("Накази для перезапису не знайдено.|Приказы для перезаписи не найдены."));
	tbn.close();
}

//закрытие приказов вместе с увольнением человека (PRK2,PRK3,PRK4)
function zakrPrik(old_fwid_wp,bdat)
{
	bdat = new Date(bdat);
	var sWhere = " AND p.Fin_table in ('PRK2','PRK3','PRK4')";
	var tbn = OpenTable("SELECT p.*, p4.Fwid_wp2, p4.Ftabn_id2, cl.Fedit "
				+" FROM ^prk_all AS p "
					+" LEFT JOIN ^prk4 AS p4 ON p.Fwid=p4.Fwid "
					+" INNER JOIN ^cl_prik as cl ON cl.Fvid=p.Fvid_prk"
			+" WHERE p.Fwid_wp="+sqlTo(old_fwid_wp)
				+sWhere
				+" AND p.Fbdat < " + sqlTo(bdat)
				+" AND p.Fedat >= " + sqlTo(bdat)
			+" ORDER BY p.Fvid_prk, p.Fbdat, p.Fedat");
	if (!tbn.IsEmpty())
	{
		var k = 0;
		for(tbn.MoveFirst(); !tbn.IsEOF(); tbn.MoveNext())
		{
			//если по какой-то причине в приказе не проставлен Ftabn_id, то проставим
			if(tbn.getValue("Ftabn_id")==null || tbn.getValue("Ftabn_id")==0)
			{
				var tabn = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+sqlTo(tbn.getValue("Fwid_wp")));
				if(tabn!=null)
					ExecuteSQL("UPDATE ^prk_all SET Ftabn_id="+sqlTo(tabn[0])+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
			}
//				//закрываем дату старого приказа
//				ExecuteSQL("UPDATE ^prk_all SET Fedat="+sqlTo(edat)+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
			var prkLbl = allt(tbn.getValue("Fedit")).toUpperCase();
			if(!prkLbl)
				continue;
			var oPrik = new DpPrik(prkLbl, tbn.getValue("Fvid_prk"));
			oPrik.loadByID(tbn.getValue("Fwid"));
			//закрываем старый
			oPrik.setVar("FEDAT", new Date(bdat).getVarDate());
			oPrik.save();
			k++;
		}
		s = ru("Кол-во закрытых приказов на новый код штатного расписания: "+k,
				"Кількість закритих наказів на новий код штатного розкладу: "+k)
		WAIT(s);
	}
	else
		WAIT(UR("Накази для закриття не знайдено.|Приказы для закрытия не найдены."));
	tbn.close();
}

//проверяет существование процедуры расчета приказов
function isExistCalc(proc)
{
	var sFile = rootDirectoryEx()+"scripts/prik/calculate/r"+proc.toLowerCase()+".js";
	return isFile(sFile);
}

//отключает нусуществующие расчеты в перечне расчетов
function disableNotExistsCalc()
{
	var toAsk = confirm(ru("Подтверждать отключение каждого несуществующего расчета?","Підтверджувати відключення кожного неіснуючого розрахунку?"));
	var t = OpenTable("SELECT p.Fnazv,p.Fproc,v.* FROM ^cl_vopl as v inner join ^cl_prik as p on v.Fpr=p.Fvid"
					+" WHERE v.Fis_slct="+sqlTrue+" and v.Fgroup<>"+sqlTrue
					+" ORDER BY v.Fvopl,v.Fnum");
	var k = 0;
	for(; !t.IsEOF(); t.MoveNext())
	{
		var proc = allt(t.getValue("Fproc").toLowerCase());
		if(proc[0]==":")
		{
			var tProc = OpenTable("select * from ^cl_proc where Flabel="+sqlTo(proc));
			for(; !tProc.IsEOF(); tProc.MoveNext())
			{
				proc = allt(tProc.getValue("Fproc").toLowerCase());
				var strAsk = ru("Отключить расчет ","Відключити розрахунок ")+proc+": №"+t.getValue("Fnum")+"(папка "+t.getValue("Fvopl")+") "+tProc.getValue("Fnazv");
				if(!isExistCalc(proc) && (!toAsk || confirm(strAsk)))
				{
					ExecuteSQL("UPDATE ^cl_vopl SET Fis_slct="+sqlFalse+ " WHERE Fwid="+t.getValue("Fwid"));
					k++;
				}
			}
			tProc.close();
		}
		else
		{
			var strAsk = ru("Отключить расчет ","Відключити розрахунок ")+proc+": №"+t.getValue("Fnum")+"(папка "+t.getValue("Fvopl")+") "+t.getValue("Fnazv");
			if(!isExistCalc(proc) && (!toAsk || confirm(strAsk)))
			{
				ExecuteSQL("UPDATE ^cl_vopl SET Fis_slct="+sqlFalse+ " WHERE Fwid="+t.getValue("Fwid"));
				k++;
			}
		}
	}
	t.close();
	alert(ru("Кол-во отключенных расчетов: ","К-сть вимкнутих розрахунків: ")+k)
}

//возвращает номер поля ЛС по коду
function getLsNum(Flsfid)
{
	var snap = getSnap("select Ffld_num from ^lic_fld where Fid="+Flsfid);
	if(snap && snap[0])
		return snap[0];
	else 
		return 0;
}

//возвращает название поля ЛС по коду
function getLsTxt(Flsfid)
{
	var snap = getSnap("select Ftxt from ^lic_fld where Fid="+Flsfid);
	if(snap && snap[0])
		return snap[0];
	else 
		return "";
}

//добавляет приказ на запись из ШР за конкретный период, если fwid_wp не передан, 
//тогда возмется максимальный соответствующий периоду,
//параметр flsfid передается, если нужно добавить готовую сумму на конкретное поле ЛС,
//toCheckExist - флаг позволяющий проверять наличие приказа по заданым параметрам,
//в случае обнаружения приказа, будет предложено его отредактировать или добавить новый
function addPrik(lbl,fvid_prk,ftabn_id,fwid_wp,bdat,edat,flsfid,toCheckExist)
{
	ftabn_id = Number(ftabn_id);
	fwid_wp = Number(fwid_wp);
	if(!ftabn_id)
	{
		if(!fwid_wp)
		{
			alert(ru("Не возможно идентифицировать сотрудника, переданы некоректные параметры ftabn_id,fwid_wp!",
					"Не можливо ідентифікувати співробітника, передані некоректні параметри ftabn_id,fwid_wp!"));
			return false;
		}
		else
		{
			var snap = getSnap("select Fwid_cl from ^work_pers where Fwid="+fwid_wp);
			if(snap && snap[0])
				ftabn_id = snap[0];
			else
			{
				alert(ru("Не возможно идентифицировать сотрудника, передан некоректный параметр fwid_wp либо запись в ШР удалена (fwid="+fwid_wp+")!",
					"Не можливо ідентифікувати співробітника, передан некоректний параметр fwid_wp або запис в ШР був вилучений (fwid="+fwid_wp+")!"));
				return false;
			}
		}
	}
	ffld_num = getLsNum(flsfid);
	var GLOBAL_TABLE = "^PRK_ALL"
	var par = new Object()
	par.dat1 = bdat;
	par.dat2 = edat;
	var oPrik = new DpPrik(lbl,fvid_prk)
	par.fvid = Number(fvid_prk); 
	if(lbl.toUpperCase()=="_SUM_2")//для готовых сумм прошлых периодов определяем имя таблицы
		oPrik.tblName = "^DLTU"+getDateTag(bdat);
	par.tblName = oPrik.tblName;
	par.priklbl = lbl;
	par.GLOBAL_TABLE = GLOBAL_TABLE;
	par.sTableName = oPrik.tblName;
	if(toCheckExist===true)//проверяем наличие приказа по данному человеку за указанный период
	{
		var snap = getSnap("select pa.Fwid,pa.Fbdat,pa.Fedat,pa.Fsum from ^prk_all as pa left join "+oPrik.tblName+" as p on pa.Fwid=p.Fwid "
				+" where pa.Fvid_prk="+fvid_prk+(lbl.toUpperCase().indexOf("_SUM_")!=-1?" and p.Flsfid="+flsfid:"")
					+" and pa.Ftabn_id="+ftabn_id+" and pa.Fbdat<="+sqlTo(edat)+" and pa.Fedat>="+sqlTo(bdat));
		if(snap && confirm("Для таб.№"+getCodFromID(ftabn_id)+ru(" найден приказ с "," знайдено наказ з ")
			+format("dd.mm.yy",snap[1])+" по "+format("dd.mm.yy",snap[2])+ru(" на сумму "," на суму ")+format("0.00",snap[3])
			+(lbl.toUpperCase().indexOf("_SUM_")!=-1?ru(" на поле лицевого счета: "," на поле особового рахунку: ")+getLsTxt(flsfid):"")
			+"\n"+ru("Поднять его на редактирование?","Подняти його на редагування?")))
		{
			par.mode = "EDIT";
			par.id = snap[0];
		}
		else
		{
			par.mode = "ADD";
			par.id = 0;
		}
	}
	else
	{
		par.mode = "ADD";
		par.id = 0;
	}
	if(!fwid_wp)
	{
		var snap = getSnap("select MAX(Fwid) from ^work_pers where Fwid_cl="+ftabn_id+" and Fbdat<="+sqlTo(edat)+" and Fedat>="+sqlTo(bdat));
		if(!snap || !snap[0])
		{
			alert(ru("Не удалось определить идентификатор записи в ШР с Fwid_cl="+ftabn_id,"Не вдалося визначити ідентифікатор запису в ШР з Fwid_cl="+ftabn_id));
			return false;
		}			
		par.fwid_wp = snap[0];
	}
	else
		par.fwid_wp = fwid_wp;
	par.m_pTable = OpenTable("select * from "+ GLOBAL_TABLE +" as pall "
					+(!oPrik.tblName? "" : 
						" left join "+ oPrik.tblName +" as p on p.FWID=pall.FWID")
					+" inner join ^WORK_PERS as wp on wp.FWID=pall.FWID_WP "
					+" inner join ^CLRELCLCL as c on wp.FWID_CL=c.FWID_CL"
					+" where pall.FWID="+ par.id);
	par.ffld_num = ffld_num;
	var oSnap = getSnap("select FNAZV from ^CL_PRIK where FVID="+ sqlTo(fvid_prk));
	if(oSnap)
		par.fnazv = oSnap[0];
	else
	{
		WAIT(ru("Не удалось определить название приказа!","Не вдалося визначити назву наказу!"));
		par.fnazv = "";
	}
	CallEditTask(oPrik.editXML, par, par.m_pTable);
	WAIT(ru("Приказ «","Наказ «")+par.fnazv+"»"+(par.mode=="ADD"?ru(" добавлен"," додано"):ru(" отредактирован"," віредаговано")));
}

//ф-я для удаления приказов готовых сумм
function delPrkSum(lbl,fvid_prk,ftabn_id,fwid_wp,bdat,edat,flsfid)
{
	ftabn_id = Number(ftabn_id);
	fwid_wp = Number(fwid_wp);
	if(!ftabn_id)
	{
		if(!fwid_wp)
		{
			alert(ru("Не возможно идентифицировать сотрудника, переданы некоректные параметры ftabn_id,fwid_wp!",
					"Не можливо ідентифікувати співробітника, передані некоректні параметри ftabn_id,fwid_wp!"));
			return false;
		}
		else
		{
			var snap = getSnap("select Fwid_cl from ^work_pers where Fwid="+fwid_wp);
			if(snap && snap[0])
				ftabn_id = snap[0];
			else
			{
				alert(ru("Не возможно идентифицировать сотрудника, передан некоректный параметр fwid_wp либо запись в ШР удалена (fwid="+fwid_wp+")!",
					"Не можливо ідентифікувати співробітника, передан некоректний параметр fwid_wp або запис в ШР був вилучений (fwid="+fwid_wp+")!"));
				return false;
			}
		}
	}
	ffld_num = getLsNum(flsfid);
	lsTxt = getLsTxt(flsfid);
	var GLOBAL_TABLE = "^PRK_ALL"
	var oPrik = new DpPrik(lbl,fvid_prk)
	if(lbl.toUpperCase()=="_SUM_2")//для готовых сумм прошлых периодов определяем имя таблицы
		oPrik.tblName = "^DLTU"+getDateTag(bdat);
	var t = OpenTable("select pa.Fwid,pa.Fbdat,pa.Fedat,pa.Fsum from ^prk_all as pa left join "+oPrik.tblName+" as p on pa.Fwid=p.Fwid "
				+" where pa.Fvid_prk="+fvid_prk+" and p.Flsfid="+flsfid
					+" and pa.Ftabn_id="+ftabn_id+" and pa.Fbdat<="+sqlTo(edat)+" and pa.Fedat>="+sqlTo(bdat));
	if(t.rowCount>0)//проверяем наличие приказа по данному человеку за указанный период
	{
		for(; !t.IsEOF(); t.MoveNext())
		{
			if(confirm("Для таб.№"+getCodFromID(ftabn_id)+ru(" найден приказ с "," знайдено наказ з ")
				+format("dd.mm.yy",t.getValue("Fbdat"))+" по "+format("dd.mm.yy",t.getValue("Fedat"))+ru(" на сумму "," на суму ")+format("0.00",t.getValue("Fsum"))
				+ru(" на поле лицевого счета: "," на поле особового рахунку: ")+lsTxt
				+(t.rowCount>1?"\n"+ru("Общее кол-во найденных приказов: ","Загальна кількість знайдених наказів: ")+t.rowCount+"\n"
					+ru("Текущий приказ №","Поточний наказ №")+t.bookmark:"")
				+"\n"+ru("Удалить его?","Вилучити його?")))
			{
				oPrik.del(Number(t.getValue("FWID")),lbl.toUpperCase()=="_SUM_2"?bdat:null);
			}
		}
	}
	else
	{
		var oSnap = getSnap("select FNAZV from ^CL_PRIK where FVID="+ sqlTo(fvid_prk));
		if(oSnap)
			fnazv = oSnap[0];
		else
		{
			WAIT(ru("Не удалось определить название приказа!","Не вдалося визначити назву наказу!"));
			fnazv = "";
		}
		alert(ru("Приказ «"+fnazv+"» на поле ЛС «"+lsTxt+"» не найден для таб.№",
				"Наказ «"+fnazv+"» на поле ОР «"+lsTxt+"» не знайдено для таб.№")+getCodFromID(ftabn_id));
	}
	t.close();
}

//расчитывает кол-во рабочих дней между датами 
function workday_difference(calend, bdat, edat)
{
	var nDays = day_difference(bdat, edat);	

	var oCal = new dpCalendar();
	oCal.setCod(calend);
	nDays = nDays - oCal.getCalDays("П",bdat, edat);
	nDays = nDays - oCal.getCalDays("В",bdat, edat);
	
	if (nDays < 0)
		nDays = 0;		
	return nDays;
}

//расчитывает дату окончания отпуска для кадровых приказов с учетом праздничных дней 
//указаных в календарях по таблице в которой занесены типы отпускных и кол-во дней 
function getOtpCdrFedat(calend,bdat,tblName,fid_doc)
{
	if(!fid_doc)
		return d00;
	var edat = new Date(bdat).getVarDate();
	var t = OpenTable("select t.Fdays,t.Fwid as Fmainwid,n.* from "+tblName+" as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid"
					+" where t.Fid_doc = " + sqlTo(fid_doc)+" order by t.Fwid");
	if(t.rowCount == 0)
	{
		WAIT(ru("Не указан ни один вид отпуска!","Не вказано жодного виду відпуски!"));
		t.close();
		return d00;
	}
	var k = 0;
	bd = new Date(bdat).getVarDate();
	for(; !t.IsEOF(); t.MoveNext())
	{
		if(!t.getValue("Fdays") || toScrObj(t.getValue("Fis_comp")))//пропускаем пустые и строки компенсации за отпуск
			continue;
		edat = goDay(bd,t.getValue("Fdays")-1);
		//если в настройках отпускных стоит признак учитывать праздничные, то удлиняем отпуск на количество праздничных дней
		if(toScrObj(t.getValue("Fsvyato"))==true)
		{
			var oCal = new dpCalendar();
			oCal.setCod(calend);
			var kol = oCal.getCalDays("П",bd,edat);
			k += kol;
			if(kol>0)
			{
				edat = goDay(edat,kol);
				var kol2 = oCal.getCalDays("П",bd,edat);
				if (kol2 > kol)
				{
					// если конец отпуска припал на праздничный день и мы пролонгировали отпуск то надо опять пересчитать кол-во праздничных дней
					k += kol2-kol;
					edat = goDay(edat,kol2-kol);
					kol = kol2;
	
					var kol3 = oCal.getCalDays("П",bd,edat);
					if (kol3 > kol2)
					{
						k += kol3-kol2;
						kol = kol3;
					}
				}
			}
			//записываем кол-во праздничных
			var m = new Object();
			m.Fpdays = kol;
			UpdateTable(tblName, m, false, "Fwid="+t.getValue("Fmainwid"));
		}
		bd = goDay(edat,1);
	}
	if(k>0)
		WAIT(ru("Отпуск продлен на кол-во праздничных дней: ","Відпустку продовжено на кількість святкових днів: ")+k)
	
	return edat;
}

//для печатных форм: возвращает перечень типов отпусков и кол-ва дней без праздничных для кадровых приказов отпускных 
function getCdrOtpPrnList(fwid_prk,ftabn_id)
{
	if(!fwid_prk || !ftabn_id)
		return "";
	var res = "";
	var t = OpenTable(s="select t.Fdays,t.Fpdays,n.* from ^otp_type as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid"
					+" where t.Fid_doc in (select Fwid from ^prk_otp where Fwid_prk="+fwid_prk+" and Fwid_cl="+ftabn_id+")"
					+" order by t.Fwid");
	for(; !t.IsEOF(); t.MoveNext())
	{
		var k = Number(t.getValue("Fdays"));//+Number(t.getValue("Fpdays"));
		if(t.bookmark == 1)
			res += format("00",k)+" к.д. - "+t.getValue("Fnazv")
		else
			res += ", "+format("00",k)+" к.д. - "+t.getValue("Fnazv")
	}
	t.close();
	return res;
}

function getCdrOtpTxt(fwid,tblName)
{
	if(!fwid)
		return "";
	var res = "";
	var t = OpenTable(s="select n.* from "+(tblName?tblName:"^otp_type")+" as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid"
					+" where t.Fid_doc="+fwid
					+" order by t.Fwid");
	for(; !t.IsEOF(); t.MoveNext())
	{
		if(t.bookmark == 1)
			res += t.getValue("Fnazv");
		else
			res += " + "+t.getValue("Fnazv");
	}
	t.close();
	return res;
}

//для гридов
function getAllOtpDays(fwid,tblName)
{
	if(!fwid)
		return 0;
	var res = 0;
	var snap = getSnap("select SUM(Fdays),SUM(Fpdays) from "+(tblName?tblName:"^otp_type")+" where Fid_doc = "+fwid);
	if(snap)
		res = Number(snap[0]) + Number(snap[1]);
	return res;
}

//для печатных форм: подсчет дней отпуска
//  mode:	'D' - кол-во дней отпуска
//			'P' - кол-во праздничных дней
//			'DP','PD',null - суммарное кол-во дней с учетом праздничных
function getOtpDays(fwid_prk,ftabn_id,mode)
{
	var days = 0;
	var snap = getSnap("select SUM(t.Fdays),SUM(t.Fpdays) from ^otp_type as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid"
					+" where t.Fid_doc in (select Fwid from ^prk_otp where Fwid_prk="+fwid_prk+" and Fwid_cl="+ftabn_id+")");
	if(snap)
	{
		if(!mode)
			days = Number(snap[0])+Number(snap[1]);
		else
		{
			mode = mode.toUpperCase();
			if(strIn("P",mode))
				days += Number(snap[1]);
			if(strIn("D",mode))
				days += Number(snap[0]);
		}
	}
	return days;
}

//определяет кол-во нормы часов в день по переданному Fwid_wp, результат округляет до precision
function getNormHoursInDay(Fwid_wp, precision)
{
	if(precision == null)
		precision = 0;
	var snap = getSnap("select Fvopl from ^work_pers where Fwid="+Fwid_wp, false);
	if(snap)
	{
		var sn = getSnap("select Fnorma_d, Fnorma_ch, Fbdat from ^tbl_ini where Fvopl="+snap[0]+" and Fbdat=(select MAX(Fbdat) from ^tbl_ini where Fvopl="+snap[0]+")");
		if(sn)
		{
			if(sn[0]!=0)
			{
				return round(sn[1]/sn[0],precision);
			}
			else
			{
				alert(ru("Не указана норма дней для вида оплаты: ","Не вказана норма днів для виду оплати: "))+snap[0]+format(" за Mmm yyyy",sn[2]).toLowerCase();
				return 0;
			}
		}
		else
		{
			alert(ru("Не возможно определить нормы времени для вида оплаты: ","Не можливо визначити норми часу для виду оплати: ")+snap[0]);
			return 0;
		}
	}
	else
	{
		alert(ru("Не найдена запись в ШР с идетификатором: ","Не знайдено запис в ШР з ідентифікатором: ")+Fwid_wp);
		return 0;
	}
}

//**************************ПОЧТОВЫЙ СБОР******************************
function post_nal(sum,rdat,tblName)
{
	if(!tblName)
		tblName = "^PROC_AL";
	if(tblName[0]!="^")
		tblName = "^"+tblName;
	var sum_nal = 0;
	var strSQL="SELECT * FROM "+tblName
			+ " WHERE Fbdat<="+sqlTo(rdat)+" and Fedat>="+sqlTo(rdat)
			+ " ORDER BY F_STSUM";
	var tpost=OpenTable(strSQL);
	for(tpost.MoveFirst(); !tpost.IsEOF(); tpost.MoveNext())
	{
		if(sum>=tpost.getValue("F_STSUM"))
		{
			sum_nal=tpost.getValue("F_PROC")>0 ? tpost.getValue("F_PROC")*sum/100 : tpost.getValue("FSUM");
		}
	}
	return sum_nal;
}

//% почтового сбора
function getProcPost(sum,rdat,tblName)
{
	if(!tblName)
		tblName = "^PROC_AL";
	if(tblName[0]!="^")
		tblName = "^"+tblName;
	var proc = 0;
	var strSQL="SELECT * FROM "+tblName
			+ " WHERE Fbdat<="+sqlTo(rdat)+" and Fedat>="+sqlTo(rdat)
			+ " ORDER BY F_STSUM";
	var tpost=OpenTable(strSQL);
	for(tpost.MoveFirst(); !tpost.IsEOF(); tpost.MoveNext())
	{
		if(sum>=tpost.getValue("F_STSUM"))
			proc = tpost.getValue("F_PROC");
	}
	return proc;
}

//текущая должность на дату
function getCurDol(tabn, dat)
{
	var snap = getSnap("select Ftxtdol from ^full_pers where Fcodpers="+tabn
					+" and Fedat>="+sqlTo(dat)+" and Fbdat<="+sqlTo(dat)+" order by fwid desc");
	if(snap)
		return snap[0];
	else
		return "???";
}

//текущее подразделение на дату
function getCurPodr(tabn, dat)
{
	var snap = getSnap("select Ftxtorg from ^full_pers where Fcodpers="+tabn
					+" and Fedat>="+sqlTo(dat)+" and Fbdat<="+sqlTo(dat)+" order by fwid desc");
	if(snap)
		return snap[0];
	else
		return "???";
}

//текущий оклад на дату
function getCurOkl(tabn, dat)
{
	var snap = getSnap("select Foklad from ^full_pers where Fcodpers="+tabn
					+" and Fedat>="+sqlTo(dat)+" and Fbdat<="+sqlTo(dat)+" order by fwid desc");
	if(snap)
		return snap[0];
	else
		return 0;
}

//расчитывает процент выслуги на дату dat по дате datvisl из справочника аналитики fcl
function getVislProc(dat,datvisl,fcl)
{
	//определяем кол-во високосных дней
	var visDays = getVisDaysCount(datvisl, dat);
	//сперва определяем кол-во полных лет без учета високосных годов
	var full_years = Math.floor(day_difference(datvisl,dat)/365);
	if(full_years>0)
	{
		//теперь коректируем среднее кол-во дней в году для данного периода и определяем кол-во полных лет более точно
		var avgDays = (full_years*365+visDays)/full_years;
		full_years = Math.floor(day_difference(datvisl,dat)/avgDays);
	}
	var snap = getSnap("select F_proc from ^listvisl where Fcl="+fcl+" and Fbdat<="+sqlTo(dat)+" and Fedat>="+sqlTo(dat)
		+" and F_year=(select MAX(F_year) from ^listvisl where Fcl="
			+fcl+" and Fbdat<="+sqlTo(dat)+" and Fedat>="+sqlTo(dat)+" and F_year<="+full_years+")");
	if(snap)
		return snap[0];
	else
		return 0;
}

//возвращает срок выслуги лет в формате y/m/d
function getVislTerm(basedat,dat)
{
	var dat1 = new Date(dat);
	var dd1 = dat1.getDate();
	var dat2 = new Date(basedat);
//	var m = month_difference(dat1,dat2)-1;
//	var months = m % 12;
//	var years = Math.floor((m-1)/12);
	var d_d = day_difference(firstDayMonth(dat1),dat2);
	var months = round(d_d/30.4375,0);
	if(months % 12 == 0 && /*dat1.getMonth() == 0 && */dd1 == 1)
		var years = months/12;
	else
		var years = Math.floor((months-1)/12);
	if(dd1 == 1)
		months = months % 12;
	else
		months = (months-1) % 12;
	months = months<0?0:months;
	var days = (dd1==1?0:lastDayMonth(goMonth(dat2,-1)).getDate())-dd1+1
	return years+"/"+months+"/"+days//+" на "+format("dd.mm.yy",basedat);
}

//возвращает срок выслуги лет в формате y/m/d по конкретному сотруднику при наличии приказа
function getVislTermByID(dat,ftabn_id)
{
	var szTag = getDateTag(dat);
	if (!IsTableEx("ZRP_RES", "ZRP_SVZP"+szTag))
		return "";
	var snap = getSnap("select h.Fwrkdat, h.Fvisldat from ^prk_all as prk inner join ^cl_homo as h on prk.Ftabn_id=h.Fwid_cl "
		+" where Fvid_prk in (select p.Fvid from ^cl_vopl as v inner join ^cl_prik as p "
			+" on v.Fpr=p.Fvid where LOWER(p.Fedit)="+sqlTo("_visl")+") and prk.Ftabn_id="+ftabn_id+" and prk.Fbdat<="+sqlTo(dat)+" and prk.Fedat>="+sqlTo(dat));
	if(snap && snap[0])
		return getVislTerm(dat,differ(snap[1],d00)==0?snap[0]:snap[1]);
	else
		return "";
}

//возвращает текстовку квалификации/звания записи из ШР
//кол-во переданных параметров:
//	1 - идентификатор записи ШР fwid_wp
//	2 - идентификатор записи сотрудника ftabn_id и дата по которой определяем запись в ШР
//	3 - идентификатор записи сотрудника ftabn_id и 2 даты по которым определяем последнюю запись в ШР
function getShtatZvanTxt()
{
	// Разбор аргументов
	var args = getShtatZvanTxt.arguments;
	switch(args.length)
	{
		case 1:  // getShtatZvanTxt(fwid_wp)
			var fwid_wp = args[0];
		break;
		case 2:  // getShtatZvanTxt(fwid_wp, dat)
			var snap = getSnap("select Fwid from ^work_pers where Fwid_cl="+args[0]+" and Fbdat<="+sqlTo(args[1])+" and Fedat>="+sqlTo(args[1]));
			if(snap && snap[0])
				var fwid_wp = snap[0];
			else
				return "";
		break;
		case 3:  // getShtatZvanTxt(fwid_wp, dat1, dat2)
			var snap = getSnap("select MAX(Fwid) from ^work_pers where Fwid_cl="+args[0]+" and Fbdat<="+sqlTo(args[2])+" and Fedat>="+sqlTo(args[1]));
			if(snap && snap[0])
				var fwid_wp = snap[0];
			else
				return "";
		break;
		default:
			WAIT("Ошибочное число аргументов для функции getShtatZvanTxt: " + args.length);
			return "";
		break;
	}
	var snap = getSnap("select Ftxtzvan from ^full_pers where Fwid="+fwid_wp+" and Fcodzvan<>0");
	if(snap)
		return snap[0];
	else
		return "";
}

//возвращает значение расширения штатного расписания
//кол-во переданных параметров:
//	2 - идентификатор расширения, идентификатор записи ШР fwid_wp
//	3 - идентификатор расширения, идентификатор записи сотрудника ftabn_id и дата по которой определяем запись в ШР
//	4 - идентификатор расширения, идентификатор записи сотрудника ftabn_id и 2 даты по которым определяем последнюю запись в ШР
function getShtatExt()
{
	// Разбор аргументов
	var args = getShtatExt.arguments;
	switch(args.length)
	{
		case 2:  // getShtatExt(fwid_wp)
			var ext = args[0];
			var fwid_wp = args[1];
		break;
		case 3:  // getShtatExt(fwid_wp, dat)
			var ext = args[0];
			var snap = getSnap("select Fwid from ^work_pers where Fwid_cl="+args[1]+" and Fbdat<="+sqlTo(args[2])+" and Fedat>="+sqlTo(args[2]));
			if(snap && snap[0])
				var fwid_wp = snap[0];
			else
				return "";
		break;
		case 4:  // getShtatExt(fwid_wp, dat1, dat2)
			var ext = args[0];
			var snap = getSnap("select MAX(Fwid) from ^work_pers where Fwid_cl="+args[1]+" and Fbdat<="+sqlTo(args[3])+" and Fedat>="+sqlTo(args[2]));
			if(snap && snap[0])
				var fwid_wp = snap[0];
			else
				return "";
		break;
		default:
			WAIT("Ошибочное число аргументов для функции getShtatExt: " + args.length);
			return "";
		break;
	}
	include("Objects/DpExtentionBuilder.js");
	var oExt = new DpExtentionBuilder("SHTATEXT");
	if(oExt.exist())
	{
		var extTblName = oExt.getValueTableName();
		var snap = getSnap("select F"+ext+" from "+extTblName+" where Fmainwid="+fwid_wp);
		if(snap)
			return snap[0];
	}
	else
		return "";
}

//формирует табель на сотрудника
function createTabel(month, ftabn_id, fwid_wp)
{
	//проверяем наличие нормы временина соответствующий вид оплаты
	var snap = getSnap("select Fvopl from ^work_pers where Fwid="+fwid_wp);
	if(snap)
	{
		var vopl = snap[0];
		snap = getSnap("select Fwid from ^tbl_ini where Fvopl="+vopl+" and Fbdat="+sqlTo(firstDayMonth(month)));
		if(!snap)
		{
			var msg = ru("Не существует нормы времени для вида оплаты "+vopl+" за "+format("Mmm yyyy", month).toLowerCase()+"\nДобавить норму?\nЕсли выбирете 'Нет', то табель будет все-равно создан, но его не будет видно в просмотре наличия табелей.",
						"Не існує норми часу для виду оплати "+vopl+" за "+format("Mmm yyyy", month).toLowerCase()+"\nДодати норму?\nЯкщо оберете 'Ні', то табель буде все-одно створено, але його не буде видно в перегляді наявності табелів.");
			if(confirm(msg))
			{
				var par = new Object();
				par.fvopl = vopl;
				par.mode = "ADD";
				par.fbdat = firstDayMonth(month);
				msg = ru("Вы уверены, что желаете отменить операцию?\nТабель не будет создан для таб.№"+getCodFromID(ftabn_id),
						"Ви впевнені, що бажаєте відмінити операцію?\nТабель не буде створено для таб.№"+getCodFromID(ftabn_id))
				do
				{
					showWindow("e_normTime.xml",SW_MODAL,par);
				}
				while(par.escape && !confirm(msg))
				
				if(par.escape)
					return false;
			}
		}
	}
	else
	{
		alert(ru("Не удалось идентифицировать запись в ШР с FWID="+fwid_wp,"Не вдалося ідентифікувати запис в ШР з FWID="+fwid_wp),ICON_ERROR);
		return false;
	}
	return r_vsp_f(month, 0, "HTML", "stt1", null, ftabn_id);
}

function chekLsKatItogs(month,ftabn_id)
{
	if(!getPar("LS_KAT"))
	{
		alert(ru("В настройках параметров не указан справочник категорий лицевых счетов!",
				"В налагодженні параметрів не вказано довідник категорій особових рахунків!"));
		return false;
	}
	var lsArray = new Array();
	var szTag = getDateTag(month);
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	
	var tblKat = OpenTable("select * from ^listcl where Fcl="+getPar("LS_KAT")+" order by Fcod");
	var strSQL = "SELECT fid FROM ^lic_fld WHERE fis6="
	var snap = getSnap(strSQL + sqlTo("н"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС: всего начислено \n"
				+ "       Пригласите разработчиков для устранения        ";
		
		alert(msg);
		tblKat.close();
		return false;
	}
	var nach_lsfid = snap[0];
	lsArray[lsArray.length] = nach_lsfid;
	
	snap = getSnap(strSQL + sqlTo("у"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС : всего удержано \n"
				+ "       Пригласите разработчиков для устранения        ";
		alert(msg);
		tblKat.close();          
		return false;
	}
	var uder_lsfid = snap[0];
	lsArray[lsArray.length] = uder_lsfid;
	
	snap = getSnap(strSQL + sqlTo("ф"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:фактически выдано\n"
				+ "       Пригласите разработчиков для устранения        ";
		alert(msg);
		tblKat.close();          
		return false;
	}
	var vidan_lsfid = snap[0];
	lsArray[lsArray.length] = vidan_lsfid;
	
	for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
	{
		var codKat = tblKat.getValue("Fcod");
		var txtKat = tblKat.getValue("Ftxt");
		var strSQL = "SELECT fid FROM ^lic_fld WHERE fis6="
		var snap = getSnap(strSQL + sqlTo("н"+codKat));
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'всего начислено' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения";
			
			alert(msg);
			tblKat.close();
			return false;
		}
		eval('var nach_lsfid'+codKat+' = snap[0];');
		lsArray[lsArray.length] = snap[0];
		
		snap = getSnap(strSQL + sqlTo("у"+codKat));
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'всего удержано' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения        ";
			alert(msg);
			tblKat.close();          
			return false;
		}
		eval('var uder_lsfid'+codKat+' = snap[0];');
		lsArray[lsArray.length] = snap[0];
		
		snap = getSnap(strSQL + sqlTo("ф"+codKat));
		if(null == snap)
		{
			msg="Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'фактически выдано' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения";
			alert(msg);
			tblKat.close();          
			return false;
		}
		eval('var vidan_lsfid'+codKat+' = snap[0];');
		lsArray[lsArray.length] = snap[0];
		
		snap = getSnap(strSQL + sqlTo("з"));
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'задолж.за прошл.' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения"
			alert(msg);
			tblKat.close();          
			return false;
		}
		eval('var dlgPrv_lsfid'+codKat+' = snap[0];');
		lsArray[lsArray.length] = snap[0];
		
		snap = getSnap(strSQL + sqlTo("б"));
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС:'задолж.на будущее' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения"
			alert(msg);
			tblKat.close();          
			return false;
		}
		eval('var dlgNxt_lsfid'+codKat+' = snap[0];');
		lsArray[lsArray.length] = snap[0];
	}
	
	var tblSVZP = OpenTable("select s.*,l.Fis6 from ^svzp"+szTag+" as s left join ^lic_fld as l on s.Flsfid=l.Fid where s.Flsfid in ("+lsArray+") "+sqlTabn+" order by Ftabn_id,Ffld_num");
	var ftabn_id = tblSVZP.getValue("Ftabn_id");
	var m = new Object();
	m.ftabn_id = "LONG";
	m.fcod = "LONG";
	m.ftxt = "TEXT";
	m.nach = "DOUBLE";
	m.uder = "DOUBLE";
	m.fact = "DOUBLE";
	m.nachkat = "DOUBLE";
	m.uderkat = "DOUBLE";
	m.factkat = "DOUBLE";
	m.isCorrect = "BOOL";
	CreateTable("check_lskat",m)
	var m = new Object();
	var nach = 0;
	var uder = 0;
	var fact = 0;
	var nachkat = 0;
	var uderkat = 0;
	var factkat = 0;
	var isCorrect = true;
	for(; !tblSVZP.IsEOF(); tblSVZP.MoveNext())
	{
		//если новый таблеьный номер, то заносим объект в массив
		if(ftabn_id != tblSVZP.getValue("Ftabn_id"))
		{
			m.ftabn_id = ftabn_id;
			m.nach = nach;
			m.uder = uder;
			m.fact = fact;
			m.nachkat = nachkat;
			m.uderkat = uderkat;
			m.factkat = factkat;
			m.isCorrect = (isCorrect && (round(nach-nachkat,2)==0) && (round(uder-uderkat,2)==0) && (round(fact-factkat,2)==0));
			UpdateTable("check_lskat", m, true);
			var m = new Object();
			var nach = 0;
			var uder = 0;
			var fact = 0;
			var nachkat = 0;
			var uderkat = 0;
			var factkat = 0;
			var isCorrect = true;
		}
		
		var fis6 = String(tblSVZP.getValue("Fis6"));
		switch(fis6)
		{
			case "н":
				nach = Number(tblSVZP.getValue("Fsum"));
			break;
			case "у":
				uder = Number(tblSVZP.getValue("Fsum"));
			break;
			case "ф":
				fact = Number(tblSVZP.getValue("Fsum"));
			break;
			default:
				fis6_0 = fis6[0];
				switch(fis6_0)
				{
					case "н":
						nachkat += Number(tblSVZP.getValue("Fsum"));
					break;
					case "у":
						uderkat += Number(tblSVZP.getValue("Fsum"));
					break;
					case "ф":
						factkat += Number(tblSVZP.getValue("Fsum"));
					break;
					default:
						//isCorrect = false;
					break;
				}
			break;
		}
	//если последняя запись, то заносим объект в массив
		if(tblSVZP.bookmark == tblSVZP.rowCount)
		{
			m.ftabn_id = tblSVZP.getValue("Ftabn_id");
			m.nach = nach;
			m.uder = uder;
			m.fact = fact;
			m.nachkat = nachkat;
			m.uderkat = uderkat;
			m.factkat = factkat;
			m.isCorrect = (isCorrect && (round(nach-nachkat,2)==0) && (round(uder-uderkat,2)==0) && (round(fact-factkat,2)==0));
			UpdateTable("check_lskat", m, true);
		}
		ftabn_id = tblSVZP.getValue("Ftabn_id");
	}
	tblSVZP.close();
	tblKat.close();
	ExecuteSQL("update check_lskat set Fcod=(select Fcod from ^clrelclcl as r where r.Fwid_cl=check_lskat.Ftabn_id)");
	ExecuteSQL("update check_lskat set Ftxt=(select Ftxt from ^cl as cl where cl.Fwid=check_lskat.Ftabn_id)");
	var tblCheck = OpenTable("select * from check_lskat where isCorrect="+sqlFalse+" order by Fcod");
	if(!tblCheck.IsEmpty())
	{
		msg = ru("Найденные ошибки.","Знайдено помилки!")+"\n"+ru("Смотри открывшийся список 'Проблемные таб.№'","Дивись список 'Проблемні таб.№'");
		WAIT(msg);
		
		var par = new Object();
		par.cells = new Object();
		par.caption = UR("Проблемні таб.№ за |Проблемные таб.№ за ")+format("Mmm yyyy",month);
	
		par.cells[1] = new Object();
		par.cells[1].name = "Fcod";
		par.cells[1].width = 3;
		par.cells[1].text = UR("Таб.№|Таб.№");
	
		par.cells[2] = new Object();
		par.cells[2].name = "=getSmallFIO(^Ftxt)";
		par.cells[2].width = 15;
		par.cells[2].text = UR("ФИО|ПІБ");
		
		par.cells[3] = new Object();
		par.cells[3].name = "nach";
		par.cells[3].width = 8;
		par.cells[3].text = UR("Нараховано|Начисленно");
		//par.cells[3].format = "%10.8f";
		
		par.cells[4] = new Object();
		par.cells[4].name = "nachkat";
		par.cells[4].width = 8;
		par.cells[4].text = UR("Нарах.по кат.|Начисл. по кат.");
		//par.cells[4].format = "%10.8f";
		
		par.cells[5] = new Object();
		par.cells[5].name = "uder";
		par.cells[5].width = 8;
		par.cells[5].text = UR("Утримано|Удержано");
		//par.cells[5].format = "%10.8f";
		
		par.cells[6] = new Object();
		par.cells[6].name = "uderkat";
		par.cells[6].width = 8;
		par.cells[6].text = UR("Утрим.по кат.|Удерж. по кат.");
		//par.cells[6].format = "%10.8f";
		
		par.cells[7] = new Object();
		par.cells[7].name = "fact";
		par.cells[7].width = 8;
		par.cells[7].text = UR("До видачі|К выдаче");
		//par.cells[7].format = "%10.8f";
		
		par.cells[8] = new Object();
		par.cells[8].name = "factkat";
		par.cells[8].width = 8;
		par.cells[8].text = UR("До вид.по кат.|К выд.по кат.");
		//par.cells[8].format = "%10.8f";
		
		browse(tblCheck, par, SW_MODAL);
	}
	else
		alert(ru("Проблем не обнаружено.","Проблем не виявлено."))
	tblCheck.close();
	return true;
}

//сумма подоходного налога по человеку
//первый параметр Ftabn_id, второй месяц за который расчитвыаем,
//если нужна сумма за период, тогда третим параметром передаем дату окончания периода
function getSumPodNalByID()
{
	var ftabn_id = getSumPodNalByID.arguments[0];
	var dat1 = firstDay(getSumPodNalByID.arguments[1]);
	var nKod = 0;
	if(getSumPodNalByID.arguments.length == 3)
		var dat2 = lastDay(getSumPodNalByID.arguments[2]);
	else
		var dat2 = lastDay(dat1);
	
	//dat1 - начало периода - первое число месяца
	//dat2 - конец периода - последнее число месяца
	
	var nSum = 0;
	var dRDate = dat1;	
	while(differ(dRDate, dat2) < 0) // идем по месяцам выбраного периода
	{
		var sTbl = "SVZP"+month_txt(dRDate);
		if (!IsTableEx("ZRP_RES","ZRP_"+sTbl))
			return nSum; //если таблица отсутствует - выходим 
		var sSQL = "SELECT SUM(s.FSUM) FROM ^"+sTbl+ " as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
					+" WHERE s.Ftabn_id="+ftabn_id+" and NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(dRDate)+") "
						+" and l.Fis1 in ("+sqlTo("s")+","+sqlTo("п")+")";
		var oSnap = getSnap(sSQL);
		nSum += Number(oSnap[0]);    //накапливаем сумму 
		dRDate = goMonth(dRDate,1);
	}
	return nSum;
}

function getNextTabnOrg(fwid_org)
{
	var snap = getSnap("select Ftabncounter, Flv1, Flv2, Flv3, Flv4 from ^stru_org where Fwid="+fwid_org);
	if(snap)
	{
		var codorg = String(snap[1])+(snap[2]!=0?(snap[2]+(snap[3]!=0?(snap[3]+(snap[4]!=0?snap[4]:"")):"")):"");
		var counter = Number(snap[0]);
		var tabnorg = Number(codorg+format("000",++counter));
		while(true)
		{
			snap = getSnap("select Fwid from ^work_pers where Ftabnorg="+tabnorg);
			if(snap)
				tabnorg = Number(codorg+format("000",++counter));
			else
				break;
		}
		return tabnorg;
	}
	else
		return null;
}

var ArrTabnOrg = new Array();
function getTabnOrg(Fwid_wp)
{
	Fwid_wp = Math.round(Number(Fwid_wp));
	if(ArrTabnOrg[Fwid_wp])
		return ArrTabnOrg[Fwid_wp];
	var snap = getSnap("select Ftabnorg from ^work_pers where Fwid="+Fwid_wp, false);
	if(snap && snap[0])
	{
		ArrTabnOrg[Fwid_wp] = Number(snap[0]);
		return snap[0]
	}
	else
		return 0;
}

//название подразделения по кодам уровней
function getTxtOrgByLvl(lv1,lv2,lv3,lv4,lv5)
{
	lv1 = lv1?Number(lv1):0;
	lv2 = lv2?Number(lv2):0;
	lv3 = lv3?Number(lv3):0;
	lv4 = lv4?Number(lv4):0;
	lv5 = lv5?Number(lv5):0;
	var snap = getSnap("select Ftxt from ^stru_org where Flv1="+lv1+" and Flv2="+lv2+" and Flv3="+lv3+" and Flv4="+lv4+" and Flv5="+lv5);
	if(snap)
		return snap[0];
	else
		return "";
}

//название подразделения по кодам уровней
function getIDOrgByLvl(lv1,lv2,lv3,lv4,lv5)
{
	if (String(lv1).indexOf(",") == -1)
	{
		lv1 = lv1?Number(lv1):0;
		lv2 = lv2?Number(lv2):0;
		lv3 = lv3?Number(lv3):0;
		lv4 = lv4?Number(lv4):0;
		lv5 = lv5?Number(lv5):0;
		var snap = getSnap("select Fwid from ^stru_org where Flv1="+lv1+" and Flv2="+lv2+" and Flv3="+lv3+" and Flv4="+lv4+" and Flv5="+lv5);
		if(snap)
			return snap[0];
		else
			return "";
	}
	else
	{
		lv1 = String(lv1);
		lv2 = lv2?Number(lv2):0;
		lv3 = lv3?Number(lv3):0;
		lv4 = lv4?Number(lv4):0;
		lv5 = lv5?Number(lv5):0;
		var strIds = "";
		var tbl = OpenTable("select Fwid from ^stru_org where Flv1 in ("+lv1+") and Flv2="+lv2+" and Flv3="+lv3+" and Flv4="+lv4+" and Flv5="+lv5);
	    for (tbl.MoveFirst();!tbl.IsEOF();tbl.MoveNext())
	    {
	    	if (strIds != "")
	    		strIds += ",";
	    	strIds += tbl.getValue("Fwid");
		}
		tbl.close();

		return strIds;
	}	
}

//название подразделения по идентификатору
function getTxtOrgByID(fwid)
{
	var snap = getSnap("select Ftxt from ^stru_org where Fwid="+fwid);
	if(snap)
		return snap[0];
	else
		return "";
}

//сохранение упрощенного больничного по дочерним приказам
function saveBlnPrk(par)
{
	var isPredpr = par.isPredpr;//формировать за счет предприятия
	var isSocstr = par.isSocstr;//формировать за счет с/с
	var oBln = par.oBln;
	var oCalend = par.oCalend;
	var lblP = oBln.getLblP();//метка приказа за счет предприятия
	var lblS = oBln.getLblS();//метка приказа за счет с/с
	var fvidP = oBln.getFidP();//код приказа за счет предприятия
	var fvidS = oBln.getFidS();//код приказа за счет с/с
	var m = par.m;//объект с полями родительского больничного
	var kodnvk = par.kodnvk?par.kodnvk:0;//код неявки
	var fwid = par.fwid;
	var isHours = oCalend.getFisHours("", m.FDAT_BOL);
	var mode = par.mode;
	if(!mode)
		mode = "EDIT";
	if(!par.oPrik && mode=="EDIT")
	{
		var snap = getSnap("select Fvid_prk from ^prk_all where Fwid="+fwid);
		if(snap)
		{
			par.oPrik = new DpPrik("_BLNOBSH",snap[0]);
			par.oPrik.loadByID(fwid);
		}
	}
	//массив имен переменных родительского больничного, которые могут влиять на виды, кол-ва и периоды дочерних приказов
	var mainVars = new Array("FDAT_BOL", "FBLN_TYPE", "FBDATP", "FEDATP", "FBDATS", "FEDATS");
	//массив идентификаторов текущих дочерних приказов
	var prkFwidsOld = new Array();
	//массив идентификаторов пересозданных дочерних приказов
	var prkFwidsNew = new Array();
	
	//при редактировании будем анализировать изменения, если они критичы, то будем удалять все дочерние приказы и создавать новые, в противном случае находить и редактировать
	var canEdit = false;
	if(mode=="EDIT")
	{
		canEdit = true;
		for(var i=0; i<mainVars.length; i++)
		{
			eval("var curVal = m."+mainVars[i]);
			if((!isDateType(curVal) && par.oPrik.getVar(mainVars[i])!=curVal) || (isDateType(curVal) && differ(new Date(par.oPrik.getVar(mainVars[i])),new Date(curVal))!=0))
			{
				canEdit = false;
				break;
			}
		}
		//формируем массив идентификаторов дочерних приказов
		var t = OpenTable("select * from ^prk_all where Fwid_prik="+fwid+" order by Fbdat");
		for(; !t.IsEOF(); t.MoveNext())
			prkFwidsOld[prkFwidsOld.length] = Number(t.getValue("Fwid"));
		t.close();
		if(!canEdit && prkFwidsOld.length>0)
		{
			var msg = ru("Данные изменения повлекут удаление существующих и повторное создание дочерних приказов! Продолжить?",
						"Дані зміни спричинять видалення існуючих і повторне створення дочірніх наказів! Продовжити?");
			if(!confirm(msg))
				return false;
			var t = OpenTable("select * from ^prk_all where Fwid_prik="+fwid);
			var oPrk = new DpPrik("_SR",0);
			for(; !t.IsEOF(); t.MoveNext())
			{
				//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
				var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
				if(snap)
				{
					ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
							+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
					ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
				}
				oPrk.del(t.getValue("Fwid"));
			}
			t.close();
		}
	}
	
	var prkInd = 0;//индекс элемента массива prkFwidsOld
	if(isPredpr)
	{
		//формируем приказ больничного за счет предприятия
		var oPrikP = new DpPrik(lblP,fvidP);
		if(canEdit && prkFwidsOld[prkInd])
			oPrikP.loadByID(prkFwidsOld[prkInd++]);
		oPrikP.setVar("FDAT_BOL",m.FDAT_BOL);
		oPrikP.setVar("FMES_VIP",m.FMES_VIP);
		oPrikP.setVar("FNOM_PRIK",m.FNOM_PRIK);
		oPrikP.setVar("FPROC",m.FPROC);
		oPrikP.setVar("FWID_WP",m.FWID_WP);
		oPrikP.setVar("FTABN_ID",m.FTABN_ID);
		oPrikP.setVar("FCALNUM",m.FCALNUM);
		//если есть константа, то берем ШПЗ по константе
		var codShpz = get_cnst("shpz_pr",m.FBDATP)
		var shpz = m.FSHPZ;
		if(codShpz)
		{
			var snap = getSnap("select Fshpz from ^SHIFRPZ where Fcod="+codShpz);
			if(snap)
				shpz = snap[0];
		}
		else
		{
			if((shpz=="" || shpz=="0" || shpz==0) && m.FWID_WP!=null)
			{
				var snap = getSnap("select sd.Fshpz from ^stru_dol as sd inner join ^work_pers as wp on sd.Fwid=wp.Fwid_dol where wp.fwid="+m.FWID_WP)
				if(snap)
					shpz = snap[0];
			}
			if(shpz!=0)
			{
				var zat = 0;	
				var strSQL = "SELECT fan FROM ^lic_fld AS f INNER JOIN ^cl_prik AS p ON f.fid = p.flsfid "
						+ " WHERE p.fvid = " + sqlTo(fvidP);
				var snap = getSnap(strSQL);
				if (snap != null)
					zat = snap[0];	
				if (zat != 0 && shpz!=0)
				{
					//*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
					switch(getPar("PRK_SHPZ"))
					{
						case 1:
							shpz = shpz + allt(String(zat));
						break;
						case 0:
						default:
							shpz = allt(String(shpz)).substring(0, allt(String(shpz)).length - 1) + allt(String(zat));
						break;
					}
				}
			}
		}
		oPrikP.setVar("FSHPZ",shpz);
		oPrikP.setVar("FIN_TABLE","PRK_B");
		//проставляем FWID родительского приказа
		oPrikP.setVar("FWID_PRIK",fwid);
		//проставляем номер больничного листа
		oPrikP.setVar("FNUM",m.FNUM);
		if(differ(firstDayMonth(m.FBDATP),firstDayMonth(m.FEDATP))==0)
		{
			oPrikP.setVar("FBDAT",m.FBDATP);
			oPrikP.setVar("FEDAT",m.FEDATP);
			oPrikP.setVar("FDNKL",day_difference(m.FBDATP,m.FEDATP));			
			oPrikP.setVar("FSUM",Number(Number(m.FDAY_P) * 1000 + Number(m.FCHAS_P)));
			//анализируем ситуацию, когда больничный по беременности и родам заносят задним числом и делают перерасчет,
			//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
			//иначе в списке ЛС в месяце выплаты суммы задвоятся
			if(differ(firstDayMonth(m.FMES_VIP),firstDayMonth(m.FBDATP))>0)
				oPrikP.setVar("FMES_VIP",firstDayMonth(m.FBDATP));
			prkFwidsNew[prkFwidsNew.length] = Number(oPrikP.getVar("HID"));
			oPrikP.save();
			//проставляем неявки
			if (kodnvk!=0)
		    	r_mnvk(oPrikP.getVar("FTABN_ID"), oPrikP.getVar("FWID_WP"), 0, 0, day_difference(oPrikP.getVar("FBDAT"),oPrikP.getVar("FEDAT")), 0, kodnvk, oPrikP.getVar("FBDAT"), oPrikP.getID());
		}
		else//переходящий месяц - бъём больничный за счет предприятия на столько частей, сколько месяцев он захватывает
		{
			var bdat = new Date(m.FBDATP).getVarDate();
			var edat = m.FEDATP;
			var isFirst = true;
			var i = 0;
			while(differ(firstDayMonth(bdat),firstDayMonth(edat))<=0)
			{
				//для последней итерации берём конечную дату общего периода, в остальных случаях последний день текущего месяца
				edat2 = differ(lastDayMonth(bdat),lastDayMonth(edat))==0?edat:lastDayMonth(bdat);
				if(oBln.isBerem() && get_cnst("br2010",m.FDAT_BOL))//для беременных по новому законодательству с 15.12.2009 берем календарные дни
				{
					var day_p = day_difference(bdat,edat2);
					var chas_p = 0;
				}
				else
				{
					var day_p = oCalend.getCalDays("Р",bdat,edat2); 
					var chas_p = isHours?oCalend.getCalHours("Р",bdat,edat2):0;
				}
				if(isFirst)
					isFirst = false;
				else
				{
					if(canEdit && prkFwidsOld[prkInd])
					{
						oPrikP.loadByID(prkFwidsOld[prkInd++]);
						oPrikP.setVar("FDAT_BOL",m.FDAT_BOL);
						oPrikP.setVar("FMES_VIP",m.FMES_VIP);
						oPrikP.setVar("FNOM_PRIK",m.FNOM_PRIK);
						oPrikP.setVar("FPROC",m.FPROC);
						oPrikP.setVar("FWID_WP",m.FWID_WP);
						oPrikP.setVar("FTABN_ID",m.FTABN_ID);
						oPrikP.setVar("FCALNUM",m.FCALNUM);
						oPrikP.setVar("FSHPZ",shpz);
						oPrikP.setVar("FWID_PRIK",fwid);
						oPrikP.setVar("FNUM",m.FNUM);
					}
					else
						oPrikP.clone();
				}
				oPrikP.setVar("FBDAT",bdat);
				oPrikP.setVar("FEDAT",edat2);
				oPrikP.setVar("FDNKL",day_difference(bdat,edat2));				
				oPrikP.setVar("FSUM",Number(Number(day_p) * 1000 + Number(chas_p)));
				//анализируем ситуацию, когда больничный по беременности и родам заносят задним числом и делают перерасчет,
				//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
				//иначе в списке ЛС в месяце выплаты суммы задвоятся
				if(differ(firstDayMonth(m.FMES_VIP),firstDayMonth(bdat))>0)
					oPrikP.setVar("FMES_VIP",firstDayMonth(bdat));
				else
					oPrikP.setVar("FMES_VIP",m.FMES_VIP);
				prkFwidsNew[prkFwidsNew.length] = Number(oPrikP.getVar("HID"));
				oPrikP.save();
				//проставляем неявки
				if (kodnvk!=0)
		    		r_mnvk(oPrikP.getVar("FTABN_ID"), oPrikP.getVar("FWID_WP"), 0, 0, day_difference(oPrikP.getVar("FBDAT"),oPrikP.getVar("FEDAT")), 0, kodnvk, oPrikP.getVar("FBDAT"), oPrikP.getID());
				bdat = goDay(lastDayMonth(edat2),1);
				if(++i>12)
				{
					if(!confirm(ru("Период больничного за счет предприятия превышает год! Продолжить разбитие больничного?",
								"Період лікарняного за рахунок підприємства перевищую рік! Продовжити розбиття лікарняного?")))
						break;
					else
						i = 0;
				}
			}
		}
	}
	if(isSocstr && (m.FDAY>m.FDAY_P || m.FCHAS>m.FCHAS_P))
	{
		var oPrikS = new DpPrik(lblS,fvidS);
		if(canEdit && prkFwidsOld[prkInd])
			oPrikS.loadByID(prkFwidsOld[prkInd++]);
		oPrikS.setVar("FDAT_BOL",m.FDAT_BOL);
		oPrikS.setVar("FMES_VIP",m.FMES_VIP);
		oPrikS.setVar("FNOM_PRIK",m.FNOM_PRIK);
		oPrikS.setVar("FPROC",m.FPROC);
		oPrikS.setVar("FWID_WP",m.FWID_WP);
		oPrikS.setVar("FTABN_ID",m.FTABN_ID);
		oPrikS.setVar("FCALNUM",m.FCALNUM);
		//если есть константа, то берем ШПЗ по константе
		var codShpz = get_cnst("shpz_soc",m.FBDATS)
		var shpz = m.FSHPZ;
		if(codShpz)
		{
			var snap = getSnap("select Fshpz from ^SHIFRPZ where Fcod="+codShpz);
			if(snap)
				shpz = snap[0];
		}
		else
		{
			if((shpz=="" || shpz=="0" || shpz==0) && m.FWID_WP!=null)
			{
				var snap = getSnap("select sd.Fshpz from ^stru_dol as sd inner join ^work_pers as wp on sd.Fwid=wp.Fwid_dol where wp.fwid="+m.FWID_WP)
				if(snap)
					shpz = snap[0];
			}
			if(shpz!=0)
			{
				var zat = 0;	
				var strSQL = "SELECT fan FROM ^lic_fld AS f INNER JOIN ^cl_prik AS p ON f.fid = p.flsfid "
						+ " WHERE p.fvid = " + sqlTo(fvidS);
				var snap = getSnap(strSQL);
				if (snap != null)
					zat = snap[0];	
				if (zat != 0 && shpz!=0)
				{
					//*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
					switch(getPar("PRK_SHPZ"))
					{
						case 1:
							shpz = shpz + allt(String(zat));
						break;
						case 0:
						default:
							shpz = allt(String(shpz)).substring(0, allt(String(shpz)).length - 1) + allt(String(zat));
						break;
					}
				}
			}
		}
		oPrikS.setVar("FSHPZ",shpz);
		oPrikS.setVar("FIN_TABLE","PRK_B");
		oPrikS.setVar("FWID_PRIK",fwid);
		oPrikS.setVar("FNUM",m.FNUM);
		oPrikS.setVar("FNUM_ZVK",m.FNUM_ZVK);
		if(differ(firstDayMonth(m.FBDATS),firstDayMonth(m.FEDATS))==0)
		{
			oPrikS.setVar("FBDAT",m.FBDATS);
			oPrikS.setVar("FEDAT",m.FEDATS);
			oPrikS.setVar("FDNKL",day_difference(m.FBDATS,m.FEDATS));			
			oPrikS.setVar("FSUM",Number(Number(m.FDAY_S) * 1000 + Number(m.FCHAS_S)));
			//анализируем ситуацию, когда больничный по беременности и родам заносят задним числом и делают перерасчет,
			//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
			//иначе в списке ЛС в месяце выплаты суммы задвоятся
			if(differ(firstDayMonth(m.FMES_VIP),firstDayMonth(m.FBDATS))>0)
				oPrikS.setVar("FMES_VIP",firstDayMonth(m.FBDATS));
			prkFwidsNew[prkFwidsNew.length] = Number(oPrikS.getVar("HID"));
			oPrikS.save();
			//проставляем неявки
			if (kodnvk!=0)
		    	r_mnvk(oPrikS.getVar("FTABN_ID"), oPrikS.getVar("FWID_WP"), 0, 0, day_difference(oPrikS.getVar("FBDAT"),oPrikS.getVar("FEDAT")), 0, kodnvk, oPrikS.getVar("FBDAT"), oPrikS.getID());
		}
		else	//переходящий месяц - бъём больничный на столько частей, сколько месяцев он захватывает
		{
			var bdat = new Date(m.FBDATS).getVarDate();
			var edat = m.FEDATS;
			var isFirst = true;
			var i = 0;
			while(differ(firstDayMonth(bdat),firstDayMonth(edat))<=0)
			{
				//для последней итерации берём конечную дату общего периода, в остальных случаях последний день текущего месяца
				edat2 = differ(lastDayMonth(bdat),lastDayMonth(edat))==0?edat:lastDayMonth(bdat);
				if(oBln.isBerem() && get_cnst("br2010",m.FDAT_BOL))//для беременных по новому законодательству с 15.12.2009 берем календарные дни
				{
					var day_s = day_difference(bdat,edat2);
					var chas_s = 0;
				}
				else
				{
					var day_s = oCalend.getCalDays("Р",bdat,edat2); 
					var chas_s = isHours?oCalend.getCalHours("Р",bdat,edat2):0;
				}
				
				if(isFirst)
					isFirst = false;
				else
				{
					if(canEdit && prkFwidsOld[prkInd])
					{
						oPrikS.loadByID(prkFwidsOld[prkInd++]);
						oPrikS.setVar("FDAT_BOL",m.FDAT_BOL);
						oPrikS.setVar("FMES_VIP",m.FMES_VIP);
						oPrikS.setVar("FNOM_PRIK",m.FNOM_PRIK);
						oPrikS.setVar("FPROC",m.FPROC);
						oPrikS.setVar("FWID_WP",m.FWID_WP);
						oPrikS.setVar("FTABN_ID",m.FTABN_ID);
						oPrikS.setVar("FCALNUM",m.FCALNUM);
						oPrikS.setVar("FSHPZ",shpz);
						oPrikS.setVar("FWID_PRIK",fwid);
						oPrikS.setVar("FNUM",m.FNUM);
						oPrikS.setVar("FNUM_ZVK",m.FNUM_ZVK);
					}
					else
						oPrikS.clone();
				}
				oPrikS.setVar("FBDAT",bdat);
				oPrikS.setVar("FEDAT",edat2);
				oPrikS.setVar("FDNKL",day_difference(bdat,edat2));				
				oPrikS.setVar("FSUM",Number(Number(day_s) * 1000 + Number(chas_s)));
				//анализируем ситуацию, когда больничный по беременности и родам заносят задним числом и делают перерасчет,
				//в таком случае для приказов относящихся к перерасчетным месяцам, месяц выплаты должен равнятся месяцу приказа, 
				//иначе в списке ЛС в месяце выплаты суммы задвоятся
				if(differ(firstDayMonth(m.FMES_VIP),firstDayMonth(bdat))>0)
					oPrikS.setVar("FMES_VIP",firstDayMonth(bdat));
				else
					oPrikS.setVar("FMES_VIP",m.FMES_VIP);
				prkFwidsNew[prkFwidsNew.length] = Number(oPrikS.getVar("HID"));
				oPrikS.save();
				//проставляем неявки
				if (kodnvk!=0)
			    	r_mnvk(oPrikS.getVar("FTABN_ID"), oPrikS.getVar("FWID_WP"), 0, 0, day_difference(oPrikS.getVar("FBDAT"),oPrikS.getVar("FEDAT")), 0, kodnvk, oPrikS.getVar("FBDAT"), oPrikS.getID());
				bdat = goDay(lastDayMonth(edat2),1);
				if(++i>12)
				{
					if(!confirm(ru("Период больничного за счет соцстраха превышает год! Продолжить разбитие больничного?",
								"Період лікарняного за рахунок соцстраху перевищую рік! Продовжити розбиття лікарняного?")))
						break;
					else
						i = 0;
				}
			}
		}
	}
	if(mode=="EDIT" && !canEdit && prkFwidsOld.length>0 && prkFwidsNew.length>0)//перебиваем идентификаторы больничных в лицевых счетах
	{
		var snap = getSnap("select MAX(Fdate) from ^chng where Fdate<>"+sqlTo(d00));
		if(snap)
		{
			var d = new Date(snap[0]).getVarDate();
			for(var i=0; i<12; i++)//будем брать ЛС на протяжении года
			{
				var szTag = getDateTag(d);
				if(IsTableEx("ZRP_RES", "ZRP_SVZP"+szTag))
				{
					for(var j=0; j<prkFwidsOld.length; j++)
					{
						if(prkFwidsNew[j])
							ExecuteSQL("update ^svzp"+szTag+" set Fid_prk="+prkFwidsNew[j]+" where Fid_prk="+prkFwidsOld[j]);
					}
				}
				d = goMonth(d, -1);
			}
		}
	}
	return true;
}

//проверка существования дочернего приказа: fwid_prk - идентификатор родительского приказа 
function isExistsDaughterPrk(fwid_prk)
{
	var snap = getSnap("select Fwid from ^prk_all where Fwid_prik="+fwid_prk, false);
	return snap!=null;
}

// текстовка для типов почтового сбора
function getTxtSb(mode, typeSb)
{
	var aIndexes = new Array();
	aIndexes[0] = "NONE";
	aIndexes[1] = "SCAL";
	aIndexes[2] = "PROC";
	aIndexes[3] = "SUMM";
	
	var aTxtSb = new Array();
	aTxtSb[aIndexes[0]] = ru("не взымается", "не утримується");
	aTxtSb[aIndexes[1]] = ru("по шкале почт. сбора", "за шкалою пошт. збору");
	aTxtSb[aIndexes[2]] = ru("фиксированный %", "фіксований %")
	aTxtSb[aIndexes[3]] = ru("фиксированная сума", "фіксована сума");
	
	if (mode == "")
	{
		typeSb = String(typeSb).trim();
		return typeof(aTxtSb[typeSb]) == "undefined" ? typeSb : aTxtSb[typeSb];
	}
	else
	{
		var par = new Object();
		par.aTxtSb = aTxtSb;
		par.aIndexes = aIndexes;
		
		return par;
	}
}

//переход на динамические контролы в табеле с переносом их в справочник неявок (для модификации)
function ctrlTabelFromNvk()
{
	var snap = getSnap("select * from ^cl_nvk where Fkod_nvk>2 and Fkod_nvk<11")
	if(!snap)
	{
		//раньше были напутаны признаки, и в строках табеля отображались неявки у которых был признак Fis_slct=true, а должно быть Fis_tbl=true
		ExecuteSQL("update ^cl_nvk set Fis_tbl="+sqlTrue+", Fis_slct="+sqlFalse+" where Fis_slct="+sqlTrue);
		var m = new Object();
		m.FWID = GetUID();
		m.FKOD_NVK = 3;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Нічні|Ночные";
		m.FNAM_NVK = "Нічні|Ночные";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 4;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Класність|Классность";
		m.FNAM_NVK = "Класність|Классность";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 5;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Святкові|Праздничные";
		m.FNAM_NVK = "Святкові|Праздничные";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 6;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Шкідливість|Вредность";
		m.FNAM_NVK = "Шкідливість|Вредность";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 7;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Відрядж.|Команд.";
		m.FNAM_NVK = "Відрядження|Командировочные";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 8;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Вечірні|Вечерние";
		m.FNAM_NVK = "Вечірні|Вечерние";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 9;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Простої|Простои";
		m.FNAM_NVK = "Простої|Простои";
		UpdateTable("^CL_NVK", m, true);
		
		m.FWID = GetUID();
		m.FKOD_NVK = 10;
		m.FIS_SLCT = true;
		m.FNAMS_NVK = "Роз'їздні|Разъездные";
		m.FNAM_NVK = "Роз'їздні|Разъездные";
		UpdateTable("^CL_NVK", m, true);
	}
}

//экспорт в дбф таблицы помесячной персонификации
function expToDbfMonthPers(tblName, sFileName, sDir, date, mode)
{
	if(date)
		date = new Date(date);
	else
		date = today;
	var tblType = tblName.replace(/(\d)|(^\W)/g,"").toUpperCase();
	switch(tblType)
	{
		case "ZPPNMV":
			var dbfTemplateName = mode==2011?"E04T05D.dbf":"E04T05F.dbf";
			var tlbNum = 5;
		break;
		case "ZPPNMVI":
		case "ZPPMVI":
			var dbfTemplateName = tblType=="ZPPMVI"?"E04T06D.dbf":"P04t06b.dbf";
			var tlbNum = 6;
		break;
		case "ZPPFMVI":
			var dbfTemplateName = tblType=="ZPPFMVI"?"E04T06F.dbf":"P04t06e.dbf";
			var tlbNum = 6;
		break;
		case "ZPPNMVIID":
			var dbfTemplateName = "P04t07b.dbf";
			var tlbNum = 7+ru(" (дополнительная)"," (додаткова)");
		break;
		case "ZPPNMVII":
			var dbfTemplateName = "P04t07b.dbf";
			var tlbNum = 7;
		break;
		case "ZPPNMVIII":
			//т.к. с 2011 года 7-я таблица исчезла, а все остальные таблицы после нее сместились в нумерации на один вниз, то будем определять номер таблицы по параметру
			var dbfTemplateName = mode==2011?"E04T07D.dbf":"P04t08b.dbf";
			var tlbNum = mode==2011?7:8;
		break;
		case "ZPPNMIX":
			var dbfTemplateName = mode==2011?"E04T09C.dbf":"P04t09b.dbf";
			var tlbNum = 9;
		break;
		case "ZPPNMX":
			var dbfTemplateName = "P04t10b.dbf";
			var tlbNum = 10;
		break;
		default:
			alert(ru("Не известная таблица ","Не відома таблиця ")+tblName.replace("^",""),2);
			return false;
		break;
	}
	if(!sFileName)
	{
		if(sDir)
		{
			if(!isDir(sDir))
			{
				var msg = ru("Директория "+sDir+" не существует.\nСоздать директорию?","Директорія "+ sDir +" не існує.\nСтворити директорію?");
				if(confirm(msg))
				{
					if(!createDirectory(sDir))
					{
						alert(ru("Не удалось создать директорию\n","Не вдалося створити директорію\n")+sDir,2);
						return false;
					}
				}
				else
					return false;
			}
			sFileName = sDir+"/"+dbfTemplateName;
		}
		else
		{
			alert(ru("Не указна директория экспорта третим параметром!","Не вказана директорія експорту третім параметром!"),2);
			return false;
		}
	} 
	if (!IsTableEx("ZRP_RES","ZRP_"+tblName.replace("^","")))
	{
		WAIT(ru("Отсутствует таблица ",	"Відсутня таблиця ")+tblName.replace("^",""));
		if(sFileName)
		{
			sFileName = new DpFile(sFileName).getCanonicalPath();
			if(isFile(sFileName))
			{
				var msg = ru("Файл "+sFileName+"\nдля таблицы "+tlbNum+" уже существует. Удалить файл?\nВ противном случае во внешнюю программу могут попасть некорректные данные.",
						"Файл "+sFileName+"\nдля таблиці "+tlbNum+" вже існує. Видалити файл?\nВ іншому випадку в зовнішню програму можуть потрапити некоректні дані.")
				if(!getPar("PNS_CONF") || (getPar("PNS_CONF") && confirm(msg)))
				{
					deleteFile(sFileName);
				}
			}
		}
		return false;
	}
	var tbl = OpenTable("select * from "+tblName+" where FTABNN>0 order by FTABNN");
	if(tbl.IsEmpty())
	{
		alert(ru("Нет данных для экспорта в таблице ","Немає даних для експорту в таблиці ")+tlbNum);
		tbl.close();
		if(sFileName)
		{
			sFileName = new DpFile(sFileName).getCanonicalPath();
			if(isFile(sFileName))
			{
				var msg = ru("Файл "+sFileName+"\nдля таблицы "+tlbNum+" уже существует. Удалить файл?\nВ противном случае во внешнюю программу могут попасть некорректные данные.",
						"Файл "+sFileName+"\nдля таблиці "+tlbNum+" вже існує. Видалити файл?\nВ іншому випадку в зовнішню програму можуть потрапити некоректні дані.")
				if(!getPar("PNS_CONF") || (getPar("PNS_CONF") && confirm(msg)))
				{
					deleteFile(sFileName);
				}
			}
		}
		return false;
	}
	if(sFileName)
	{
		sFileName = new DpFile(sFileName).getCanonicalPath();
		var dbfRowCount = 0;
		if(isFile(sFileName) && getPar("PNS_CONF"))
		{
			var msg = ru("Файл "+sFileName+"\nуже существует. Добавить в него данные?\nВ противном случае файл будет перезаписан.",
						"Файл "+sFileName+"\nвже існує. Додати до нього дані?\nВ іншому випадку файл буде перезаписаний.")
			if(!confirm(msg))
			{
				var templateFile = rootDirectoryEx()+"Source/dbftemplate/"+dbfTemplateName;
				if(!isFile(templateFile))
				{
					alert(ru("Отсутствует эталонный файл ","Відсутній еталонний файл")+"\n"+templateFile,2)
					return false;
				}
				copyFile(templateFile, sFileName);
			}
			else
			{
				var tdbf = OpenTable("f",sFileName);
				dbfRowCount = tdbf.rowCount;
				tdbf.close();
			}
		}
		else
			copyFile(rootDirectoryEx()+"Source/dbftemplate/"+dbfTemplateName, sFileName);
		oDDBF = lpProxy.getDBManager().getDBFWriter(sFileName);
		oDDBF.setCharactersetName(getPar("PNS_ENC"));
		setProgressRange(1, tbl.rowCount);
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			setProgressPos(tbl.bookmark, tbl.bookmark+"/"+tbl.rowCount);
			switch(tblType)
			{
				case "ZPPNMV":
					if(mode==2011)
					{
						var fldsAr = new Array(
							date.getMonth()+1//PERIOD_M
							,date.getFullYear()//PERIOD_Y
							,tbl.bookmark+dbfRowCount//ROWNUM
							,toScrObj(tbl.getValue("FGRUKR"))//UKR_GROMAD
							,toScrObj(tbl.getValue("FKATOSOB"))//ZO
							,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
							,toScrObj(reTrans(tbl.getValue("FLD7F")))//LN
							,toScrObj(reTrans(tbl.getValue("FLD7I")))//NM
							,toScrObj(reTrans(tbl.getValue("FLD7O")))//FTN
							,toScrObj(differ(new Date(tbl.getValue("FBDAT")),d00obj)==0?null:tbl.getValue("FBDAT").getDate())//START_DT
							,toScrObj(differ(new Date(tbl.getValue("FEDAT")),d00obj)==0?null:tbl.getValue("FEDAT").getDate())//END_DT
							,toScrObj(reTrans(tbl.getValue("FPRICHUV")))//PID_ZV
						);
					}
					else
					{
						if(mode!=2013){
							var fldsAr = new Array(
								tbl.bookmark+dbfRowCount//ROWNUM
								,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
								,toScrObj(reTrans(tbl.getValue("FLD7F")))//LN
								,toScrObj(reTrans(tbl.getValue("FLD7I")))//NM
								,toScrObj(reTrans(tbl.getValue("FLD7O")))//FTN
								,toScrObj(differ(new Date(tbl.getValue("FBDAT")),d00obj)==0?0:tbl.getValue("FBDAT").getDate())//START_DT
								,toScrObj(differ(new Date(tbl.getValue("FEDAT")),d00obj)==0?0:tbl.getValue("FEDAT").getDate())//END_DT
								);
						}else{

							var d = new Date(tbl.getValue("FDATNEWRM"))
							var cnrm_dt =	((d.getDate()<9)?"0":"") + d.getDate() + ((d.getMonth()<9)?"0":"") + (d.getMonth()+1) + d.getFullYear()
							var fldsAr = new Array(
							date.getMonth()+1//PERIOD_M
							,date.getFullYear()//PERIOD_Y
							,tbl.bookmark+dbfRowCount//ROWNUM
							,toScrObj(tbl.getValue("FGRUKR"))//UKR_GROMAD
							,toScrObj(tbl.getValue("FKATOSOB"))//ZO
							,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
							,toScrObj(reTrans(tbl.getValue("FLD7F")))//LN
							,toScrObj(reTrans(tbl.getValue("FLD7I")))//NM
							,toScrObj(reTrans(tbl.getValue("FLD7O")))//FTN
							,toScrObj(differ(new Date(tbl.getValue("FBDAT")),d00obj)==0?null:tbl.getValue("FBDAT").getDate())//START_DT
							,toScrObj(differ(new Date(tbl.getValue("FEDAT")),d00obj)==0?null:tbl.getValue("FEDAT").getDate())//END_DT
							,toScrObj(differ(d,d00obj)==0?reTrans(''):reTrans(cnrm_dt))//NRM_DT							
							,toScrObj(reTrans(tbl.getValue("FPRICHUV")))//PID_ZV
							);

						}
					}
				break;
				case "ZPPNMVI":
					var fldsAr = new Array(
						tbl.bookmark+dbfRowCount//ROWNUM
						,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
						,toScrObj(reTrans(tbl.getValue("FLD7F")))//LN
						,toScrObj(reTrans(tbl.getValue("FLD7I")))//NM
						,toScrObj(reTrans(tbl.getValue("FLD7O")))//FTN
						,toScrObj(tbl.getValue("FLD8"))//ZO
						,toScrObj(tbl.getValue("FLD9"))//ZIC
						,toScrObj(tbl.getValue("FLD10"))//SUM_TOTAL
						,toScrObj(tbl.getValue("FLD11"))//SUM_MAX
						,toScrObj(tbl.getValue("FLD12"))//SUM_INS
						,toScrObj(tbl.getValue("FLD13"))//OTK
						,toScrObj(tbl.getValue("FLD14"))//EXP
					);
				break;
				case "ZPPMVI":
					var fldsAr = new Array(
						date.getMonth()+1//PERIOD_M
						,date.getFullYear()//PERIOD_Y
						,tbl.bookmark+dbfRowCount//ROWNUM
						,toScrObj(tbl.getValue("FGRUKR"))//UKR_GROMAD
						,tbl.getValue("FLD7")=="ж"?0:1//ST
						,toScrObj(tbl.getValue("FLD8"))//NUMIDENT
						,toScrObj(reTrans(tbl.getValue("FLD12F")))//LN
						,toScrObj(reTrans(tbl.getValue("FLD12I")))//NM
						,toScrObj(reTrans(tbl.getValue("FLD12O")))//FTN
						,toScrObj(tbl.getValue("FLD9"))//ZO
						,toScrObj(tbl.getValue("FLD10"))>0?toScrObj(tbl.getValue("FLD10")):null//PAY_TP
						,differ(date,new Date(tbl.getValue("FMES")))!=0?tbl.getValue("FMES").getMonth()+1:null//PAY_MNTH
						,differ(date,new Date(tbl.getValue("FMES")))!=0?new Date(tbl.getValue("FMES")).getFullYear():null//PAY_YEAR
						,toScrObj(tbl.getValue("FKLDNB"))//KD_NP
						,toScrObj(tbl.getValue("FKLDNO"))//KD_NZP
						,toScrObj(tbl.getValue("FLD13"))//SUM_TOTAL
						,toScrObj(tbl.getValue("FLD14"))//SUM_MAX
						,toScrObj(tbl.getValue("FLD15"))//SUM_INS
						,toScrObj(tbl.getValue("FLD16"))//OTK
						,toScrObj(tbl.getValue("FLD17"))//EXP
					);
				break;
				case "ZPPFMVI":
					var fldsAr = new Array(
						date.getMonth()+1//PERIOD_M
						,date.getFullYear()//PERIOD_Y
						,tbl.bookmark+dbfRowCount//ROWNUM
						,toScrObj(tbl.getValue("FGRUKR"))//UKR_GROMAD
						,tbl.getValue("FLD7")=="ж"?0:1//ST
						,toScrObj(tbl.getValue("FLD8"))//NUMIDENT
						,toScrObj(reTrans(tbl.getValue("FLD12F")))//LN
						,toScrObj(reTrans(tbl.getValue("FLD12I")))//NM
						,toScrObj(reTrans(tbl.getValue("FLD12O")))//FTN
						,toScrObj(tbl.getValue("FLD9"))//ZO
						,toScrObj(tbl.getValue("FLD10"))>0?toScrObj(tbl.getValue("FLD10")):null//PAY_TP
						,new Date(tbl.getValue("FMES")).getMonth()+1//PAY_MNTH								
						,new Date(tbl.getValue("FMES")).getFullYear()//PAY_YEAR
						,toScrObj(tbl.getValue("FKLDNB"))//KD_NP
						,toScrObj(tbl.getValue("FKLDNO"))//KD_NZP
						,toScrObj(tbl.getValue("FKLDNR"))//KD_PTV						
						,toScrObj(tbl.getValue("FLD13"))//SUM_TOTAL
						,toScrObj(tbl.getValue("FLD14"))//SUM_MAX
						,toScrObj(tbl.getValue("FLD15"))//SUM_INS
						,toScrObj(tbl.getValue("FLD16"))//OTK
						,toScrObj(tbl.getValue("FLD17"))//EXP
						,toScrObj(tbl.getValue("FNEWRM"))//NRM						
					);
			//,differ(date,new Date(tbl.getValue("FMES")))!=0?tbl.getValue("FMES").getMonth()+1:null//PAY_MNTH
			//				,differ(date,new Date(tbl.getValue("FMES")))!=0?new Date(tbl.getValue("FMES")).getFullYear():null//PAY_YEAR
					
				break;
				case "ZPPNMVII":
					var fldsAr = new Array(
						tbl.bookmark+dbfRowCount//ROWNUM
						,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
						,toScrObj(reTrans(tbl.getValue("FLD7F")))//LN
						,toScrObj(reTrans(tbl.getValue("FLD7I")))//NM
						,toScrObj(reTrans(tbl.getValue("FLD7O")))//FTN
						,toScrObj(tbl.getValue("FLD8"))//ZO
						,toScrObj(tbl.getValue("FLD9"))//PAY_TP
						,toScrObj(differ(new Date(tbl.getValue("FLD10")),d00obj)==0?0:Number(tbl.getValue("FLD10").getMonth())+1)//PAY_MNTH
						,toScrObj(differ(new Date(tbl.getValue("FLD10")),d00obj)==0?0:Number(tbl.getValue("FLD10").getYear())+1900)//PAY_YEAR
						,toScrObj(tbl.getValue("FLD11"))//PAY_TP
						,toScrObj(tbl.getValue("FLD12"))//SUM_TOTAL
						,toScrObj(tbl.getValue("FLD13"))//SUM_MAX
						,toScrObj(tbl.getValue("FLD14"))//SUM_INS
						,toScrObj(tbl.getValue("FLD15"))//OTK
						,toScrObj(tbl.getValue("FLD16"))//EXP
					);
				break;
				case "ZPPNMVIII":
					if(mode==2011)
					{
						var strDat = "0";
						if(differ(new Date(tbl.getValue("FDT_NAK")),d00obj)!=0)
							strDat = format("ddmmyyyy",tbl.getValue("FDT_NAK"));
						var numDat = parseInt(strDat, 10);
						var fldsAr = new Array(
							date.getMonth()+1//PERIOD_M
							,date.getFullYear()//PERIOD_Y
							,tbl.bookmark+dbfRowCount//ROWNUM
							,toScrObj(tbl.getValue("FGRUKR"))//UKR_GROMAD
							,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
							,toScrObj(reTrans(tbl.getValue("FLD8F")))//LN
							,toScrObj(reTrans(tbl.getValue("FLD8I")))//NM
							,toScrObj(reTrans(tbl.getValue("FLD8O")))//FTN
							,toScrObj(tbl.getValue("FLD7"))//C_PID
							,toScrObj(differ(new Date(tbl.getValue("FBDAT")),d00obj)==0 || !tbl.getValue("FBDAT")?0:tbl.getValue("FBDAT").getDate())//START_DT
							,toScrObj(differ(new Date(tbl.getValue("FEDAT")),d00obj)==0 || !tbl.getValue("FEDAT")?0:tbl.getValue("FEDAT").getDate())//STOP_DT
							,toScrObj(tbl.getValue("FLD12"))//DAYS	
							,0,0,0
							,toScrObj(tbl.getValue("FLD15"))//NORMA
							,toScrObj(tbl.getValue("FNUM_NAK"))//NUM_NAK
							,numDat//DT_NAK
							,toScrObj(tbl.getValue("FLD16"))//SEAZON					
						);
					}
					else
					{
						var fldsAr = new Array(
							tbl.bookmark+dbfRowCount//ROWNUM
							,toScrObj(tbl.getValue("FLD6"))//NUMIDENT
							,toScrObj(reTrans(tbl.getValue("FLD8F")))//LN
							,toScrObj(reTrans(tbl.getValue("FLD8I")))//NM
							,toScrObj(reTrans(tbl.getValue("FLD8O")))//FTN
							,toScrObj(tbl.getValue("FLD7"))//C_PID
							,toScrObj(tbl.getValue("FLD12"))//DAYS					
							,toScrObj(differ(new Date(tbl.getValue("FBDAT")),d00obj)==0?0:tbl.getValue("FBDAT").getDate())//START_DT
							,toScrObj(differ(new Date(tbl.getValue("FEDAT")),d00obj)==0?0:tbl.getValue("FEDAT").getDate())//END_DT
							,0,0,0
							,toScrObj(tbl.getValue("FLD16"))
							,toScrObj(tbl.getValue("FLD15"))						
						);
					}
				break;
				case "ZPPNMIX":
					alert("under construction",1);
					tbl.close();
					return false;
				break;
				case "ZPPNMX":
					alert("under construction",1);
					tbl.close();
					return false;
				break;
				default:
					alert(ru("Не известная таблица ","Не відома таблиця ")+tblName.replace("^",""),2);
					tbl.close();
					return false;
				break;
			}
			oDDBF.addRecord(fldsAr);
		}
		oDDBF.write();
		setProgressPos(0);
		alert(ru("Экспорт файла ","Експорт файлу ")+sFileName+ru(" окончен."," завершено.")+"\n"
			+ ru("Кол-во экспортированных из таблицы "+tlbNum+" записей: ","Кількість експортованих з таблиці "+tlbNum+" записів: ")+tbl.rowCount);
	}
	tbl.close();
	return true;
}

//создает приказ 1-ДФ для ЧП
//fvid - код приказа
//dat - начало квартала
//cod - код начисления
//ind - идентификационный номер
//sum_nach - сумма начисления
//sum_vypl - сумма выплаты
//sum_nal_nach - сумма подох.налога начисленного
//sum_nal_ud - сумма подох.налога удержаного
function addPrikDf2(fvid, dat, cod, ind, sum_nach, sum_vypl, sum_nal_nach, sum_nal_ud)
{
	var oPrik = new DpPrik("_DF2",fvid);
	oPrik.setVar("FBDAT",dat);
	oPrik.setVar("TIN",ind);
	oPrik.setVar("FVIDNACH",cod);
	oPrik.setVar("FSUMN",sum_nach);
	oPrik.setVar("FSUM",sum_vypl);
	oPrik.setVar("FSUMNALN",sum_nal_nach);
	oPrik.setVar("FSUMNAL",sum_nal_ud);
	oPrik.setVar("FIN_TABLE","PRK8DRD");
	oPrik.save();
}

function r_timeNvk(D1, D2, tabn_id, wid_wp, calNum, toIgnorID)
{
	tabn = getClcodByID(getPar("CODPERS"),tabn_id)
	if(isEmpty(calNum))
	{
		calNum = 0;
	}
	
	// массив с временем по неявкам
	var aIsNvk = new Array();
	var aIsNvkSet = new Array();
	var aNvkDays = new Array();
	var aNvkCalendDays = new Array();
	var aNvkChas = new Array();

	var par = new Object();
	par.kolTotWrkDays = 0;
	par.kolTotWrkChas = 0;
	par.kolFactWrkDays = 0;
	par.kolFactWrkChas = 0;
	par.aNvkDays = aNvkDays;
	par.aNvkChas = aNvkChas;
	par.aNvkCalendDays = aNvkCalendDays;
	par.aIsNvk = aIsNvk;
	par.aIsNvkSet = aIsNvkSet;
	par.isErr = true;
	
	var kolDaysNvk = 0;
	var kolDaysNvkCalend = 0;
	var kolChasNvk = 0;
	
	var kolDaysNvk2 = 0;
	var kolChasNvk2 = 0;

	var kolTotWrkDays = 0;
	var kolTotWrkChas = 0;
	var kolFactWrkDays = 0;
	var kolFactWrkChas = 0;
	
	var isNvk = false;
	
	var oCalend = new dpCalendar();
	oCalend.setCod(calNum);
	if (!oCalend.getFisTabn("", D1, tabn))
	{
		tabn4Calend = 0;
	}
	else
	{
		tabn4Calend = tabn;
	}
	
	if (!oCalend.isCalend("S", D1, tabn4Calend))
	{
		return par;
	}
	
	// узнаем данные о неявках: отпуска, больничные
	strSQL = "SELECT * FROM ^CL_NVK "
			+" WHERE FIS_SUBTRACT = "+sqlTrue
				+" OR FIS_SETNVK = "+sqlTrue//также обрабатываем те неявки, где нужно проставить лишь признак наличия
	
	var tblNvk = OpenTable(strSQL);
	var listPrik = "";

	// количество рабочих дней/часов
	kolTotWrkDays = oCalend.getCalDays("Р", D1, D2, tabn4Calend, true);
	kolTotWrkChas = oCalend.getCalHours("Р", D1, D2, tabn4Calend, true);
	for (; !tblNvk.IsEOF(); tblNvk.MoveNext())
	{
		var mFkod_nvk = toScrObj(tblNvk.getValue("FKOD_NVK"));
		strSQL = "SELECT FVID FROM ^CL_PRIK WHERE FZ13 = "+mFkod_nvk
												+" OR FZ14 = "+mFkod_nvk//также учитываем дополнительные неявки
		var tblPrik = OpenTable(strSQL);
		
		for (; !tblPrik.IsEOF(); tblPrik.MoveNext())
		{
			var listPrik = listPrik+","+toScrObj(tblPrik.getValue("FVID"));
		}
		
		tblPrik.Close(5652);
		tblPrik = null;
		
		listPrik = String(listPrik.substr(1)).trim();
		
		//фактическое время табеля будет уменьшать на время неявок только при соответсвующем признаке неявки 
		if(!isEmpty(listPrik) && toScrObj(tblNvk.getValue("FIS_SUBTRACT")))
		{
			strSQL = "SELECT * FROM ^PRK_ALL WHERE FVID_PRK IN ("+listPrik+") "
					+" AND FTABN_ID = "+sqlTo(tabn_id)
					+(toIgnorID==true?"":" AND FWID_WP = "+sqlTo(wid_wp))
					+getStrWhere("", D1, D2)
			var tblPrk_all = OpenTable(strSQL);
			for (; !tblPrk_all.IsEOF(); tblPrk_all.MoveNext())
			{
				isNvk = true;
				// находим количество времени данной неявки
				// т.к. данный расчет запускается раз в месяц, то время будем считать 
				// по календарю между датами начала и окончания
				prikBdat = new Date(toScrObj(tblPrk_all.getValue("FBDAT")));
				prikedat = new Date(toScrObj(tblPrk_all.getValue("FEDAT")));
				sfbdat = D1 > prikBdat ? D1 : prikBdat;
				sfedat = D2 < prikedat ? D2 : prikedat;
	
				// количество рабочих дней занятых неявкой
				var nD = oCalend.getCalDays("Р", sfbdat, sfedat, tabn4Calend, true);
				var nCh = oCalend.getCalHours("Р", sfbdat, sfedat, tabn4Calend, true);
				//var nCalendD = day_difference(sfbdat, sfedat);
				var nCalendD = oCalend.getCalDays("Р", sfbdat, sfedat, tabn4Calend, true)
							+oCalend.getCalDays("В", sfbdat, sfedat, tabn4Calend, true);
				
				kolDaysNvk += nD;
				kolChasNvk += nCh;
				kolDaysNvkCalend += nCalendD;
				kolDaysNvk2 += nD;
				kolChasNvk2 += nCh;
			}
			tblPrk_all.close();
		}
		else
		{
			if(!isEmpty(listPrik) && toScrObj(tblNvk.getValue("FIS_SETNVK")))
			{
				strSQL = "SELECT * FROM ^PRK_ALL WHERE FVID_PRK IN ("+listPrik+") "
						+" AND FTABN_ID = "+sqlTo(tabn_id)
						+(toIgnorID==true?"":" AND FWID_WP = "+sqlTo(wid_wp))
						+getStrWhere("", D1, D2)
				var tblPrk_all = OpenTable(strSQL);
				if(tblPrk_all.rowCount>0)
					aIsNvkSet[mFkod_nvk] = true;//флаг, для того что бы проставлять обязательно признак наличия неявки
				tblPrk_all.close;
			} 
		}
		
		
		// количество фактически отработанных дней/часов
		kolFactWrkDays = kolTotWrkDays - kolDaysNvk;
		kolFactWrkChas = kolTotWrkChas - kolChasNvk;

		aNvkDays[mFkod_nvk] = kolDaysNvk2;
		aNvkChas[mFkod_nvk] = kolChasNvk2;
		aNvkCalendDays[mFkod_nvk] = kolDaysNvkCalend;
		aIsNvk[mFkod_nvk] = true;

		kolDaysNvk2 = 0;
		kolDaysNvkCalend = 0;
		kolChasNvk2 = 0;
		
		listPrik = "";
	}
	
	if (!isNvk)
	{
		// неявок нет
		kolFactWrkDays = oCalend.getCalDays("Р", D1, D2, tabn4Calend, true);
		kolFactWrkChas = oCalend.getCalHours("Р", D1, D2, tabn4Calend, true);
	}
	tblNvk.Close(5652);
	tblNvk = null;

	// норма
	par.kolTotWrkDays = kolTotWrkDays;
	par.kolTotWrkChas = kolTotWrkChas;
	
	// факт
	par.kolFactWrkDays = kolFactWrkDays < 0 ? 0 : kolFactWrkDays;
	par.kolFactWrkChas = kolFactWrkChas < 0 ? 0 : kolFactWrkChas;
	par.isErr = false;
	return par;
}

function getStrWhere(alias, D1, D2)
{
	var strWhere = "";
	if (isEmpty(alias))
	{
		strWhere = " AND ((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") "
			+ " OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") "
			+ " OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))"
	}
	else
	{
		strWhere = " AND (("+alias+".FBDAT <= " + sqlTo(D1) + " AND "+alias+".FEDAT >= " + sqlTo(D2) +") "
			+ " OR ("+alias+".FBDAT >= " + sqlTo(D1) + " AND "+alias+".FBDAT <= " + sqlTo(D2) +") "
			+ " OR ("+alias+".FEDAT >= " + sqlTo(D1) + " AND "+alias+".FEDAT <= " + sqlTo(D2) +"))"
	}
	return strWhere;
}


function constEval(expr, dat, varAr)
{
	expr = allt(expr);
	//если передан массив с переменными, то заменяем в выражении переменные на соответствующие значения
	if(typeof(varAr)=="object" && varAr.length>0)
	{
		for(var i in varAr)
			expr = java.lang.String(expr).trim().replaceAll(i, varAr[i]);
	}
	var k = 0;
	//чтобы в выражении можно было обратиться к дате, на которую расчитывается константа, заменяем в выражении constDate на переменную даты dat
	expr = String(java.lang.String(expr).trim().replaceAll("^constDate", "dat"));
	expr = String(java.lang.String(expr).trim().replaceAll("constDate", "dat"));
	while(expr.indexOf("^")>-1)
	{
		var indb = expr.indexOf("^");
trace("indb>>"+indb)
		var str = expr.substr(indb+1, expr.length);
trace("str>>"+str)
		//ищем позицию не буквы, не цифры и не символа подчеркивания
		var inde = str.search(/\W/);
trace("inde>>"+inde)
		var cnst = inde==-1?str:str.substr(0,inde);
trace("cnst>>"+cnst)
		//заменяем в выражении обращения к константе на вызов функци этой константы
		expr = String(java.lang.String(expr).trim().replaceAll("\\^"+cnst, "get_cnst('"+cnst+"', dat)"));
		if(k++>2)
			break;
trace("expr>>"+expr)
	}

	try
	{
trace("eval>>"+eval(expr))
		return eval(expr);
	}
	catch(e)
	{
trace("eval error>> "+e)
		WAIT(ru("Ошибка в выражении  функции constEval!","Помилка у виразу функції constEval"))
	}
	return null;
}

function addEsvFields(isSilenceMode)
{
	var kzo = getPar("ZRP_KZO");
	//добавляем в справочник категорий застрахованных лиц новые записи
	if(kzo)
	{
		var arTxt = new Array();
		var arTxts = new Array();
		arTxt[25] = "Наймані працівники, які працюють на посадах, робота на яких зараховується до стажу, що дає право " +
				"на одержання пенсії відповідно до законів України “Про державну службу”, “Про прокуратуру”, “Про державну " +
				"підтримку засобів масової інформації та соціальний захист журналістів”, “Про наукову і науково-технічну діяльність”, " +
				"“Про статус народного депутата України”, “Про Національний банк України”, “Про службу в органах місцевого самоврядування”, " +
				"Митного кодексу України, Положення про помічника-консультанта народного депутата України, затвердженого Постановою Верховної Ради України від 13 жовтня 1995 року";
		arTxts[25] = "Наймані працівники, які працюють на посадах, робота на яких зараховується до стажу, що дає право " +
				"на одержання пенсії відповідно до окремих  Законів України";
		arTxt[26] = "Фізичні особи, які виконують роботи (надають послуги) на підприємствах, в установах та організаціях, " +
				"в інших юридичних осіб, зазначених в абзаці другому пункту 1 цієї частини, чи у фізичних осіб – підприємців " +
				"або осіб, які забезпечують себе роботою самостійно, за цивільно-правовими договорами (крім фізичних осіб – підприємців, " +
				"якщо виконувані ними роботи (надані послуги) відповідають видам діяльності, зазначеним у свідоцтві про державну реєстрацію їх як підприємців)";
		arTxts[26] = "Для осіб, що працюють за угодами ЦПХ";
		arTxt[27] = "Особи, які працюють на підприємствах та організаціях всеукраїнських громадських організацій інвалідів, " +
				"зокрема товариствах УТОГ та УТОС, в яких кількість інвалідів становить не менше як 50% загальної чисельності працюючих, " +
				"і за умови, що фонд оплати праці таких інвалідів становить не менше як 25% суми витрат на оплату праці і які нараховують " +
				"єдиний внесок у розмірі 5,3% на весь фонд оплати праці, що є базою для нарахування єдиного внеску відповідно з пунктом " +
				"1 частини першої статті 7 Закону України  'Про збір та облік єдиного внеску на загальнообовязкове державне соціальне страхування'";
		arTxts[27] = "Особи, які працюють на підприємствах та організаціях всеукраїнських громадських організацій інвалідів, зокрема товариствах УТОГ та УТОС";
		arTxt[28] = "Особи, які працюють на підприємствах та організаціях громадських організацій інвалідів, в яких кількість інвалідів " +
				"становить не менше як 50% загальної чисельності працюючих, і за умови, що фонд оплати праці таких інвалідів становить " +
				"не менше як 25% суми витрат на оплату праці і які нараховують єдиний внесок у розмірі 5,5% на фонд оплати праці працюючих інвалідів, " +
				"що є базою для нарахування єдиного внеску відповідно з пунктом 1 частини першої статті 7 Закону України  'Про збір та облік " +
				"єдиного внеску на загальнообовязкове державне соціальне страхування'";
		arTxts[28] = "Працюючий інвалід на підприємстві або організації громадських організацій інвалідів, в яких кількість інвалідів понад 50%";
		arTxt[29] = "Особи, які отримують допомогу по тимчасовій непрацездатності";
		arTxts[29] = "Особи, які отримують допомогу по тимчасовій непрацездатності";
		arTxt[30] = "Наймані працівники - інваліди, які працюють на підприємствах та організаціях всеукраїнських громадських організацій інвалідів, " +
				"зокрема товариствах УТОГ та УТОС, в яких кількість інвалідів становить не менше як 50% загальної чисельності працюючих, і за умови, " +
				"що фонд оплати праці таких інвалідів становить не менше як 25% суми витрат на оплату праці і які нараховують єдиний внесок " +
				"у розмірі 5,3% на весь фонд оплати праці, що є базою для нарахування єдиного внеску відповідно з пунктом 1 частини першої " +
				"статті 7 Закону України  'Про збір та облік єдиного внеску на загальнообовязкове державне соціальне страхування'";
		arTxts[30] = " Найманий працівник - інвалід, який працює на підприємствах та організаціях всеукраїнських громадських організацій інвалідів, зокрема товариствах УТОГ та УТОС";
		arTxt[31] = "Військовослужбовці (крім військовослужбовців строкової військової служби), особи рядового і начальницького складу";
		arTxts[31] = "Військовослужбовці, особи рядового і начальницького складу";
		include("Objects/DpClEx.js");
		for(var i=25; i<=31; i++)
		{
			var snap = getSnap("select Fwid_cl from ^clrelclcl where Fcl="+kzo+" and Fcod="+i, false);
			if(!snap)
			{
				var oCl = new DpClEx("CL5",kzo);
				oCl.setVar("HCOD", i);
				oCl.setVar("HTXT", arTxt[i]);
				oCl.setVar("HTXTS", arTxts[i]);
				oCl.save();
			}
		}
	}
	else
	{
		var msg = ru("В меню '"+getParItemPath("ZRP_KZO", true)+"' установите код соответствующего справочника",
 				"В меню '"+getParItemPath("ZRP_KZO", true)+"' встановіть код відповідного довідника");
 		if(isSilenceMode)
 			trace("<<ERROR>> "+msg);
 		else
 			alert(msg);
	}
	//проверяем наличие признака удержений/начилений единого социального взноса
	var snap = getSnap("select COUNT(*) from ^lic_fld where Fis30='+'", false);
	if(snap && snap[0]==0)
		ExecuteSQL("update ^lic_fld set Fis30="+sqlTo("+")+" where Fis8 in ('?','+','*','&')");
	var snap = getSnap("select COUNT(*) from ^lic_fld where Fesv in ('*','#','+','r','&')", false);
	if(snap && snap[0]==0)
		ExecuteSQL("update ^lic_fld set Fesv=Fis20");
	var freeFid = 1000;
	var esvNum = 1000;
	snap = getSnap("select MAX(Ffld_num) from ^lic_fld where Fis8="+sqlTo("п"));
	if(snap)
		esvNum = Number(snap[0])+1;
	//проставляем в полях ЛС по признаку ФОТ коды категорий застрахованных лиц для больничных и трудовых соглашений
	ExecuteSQL("update ^lic_fld set Fkatesv=29 where Ffzp in ("+sqlTo("б")+","+sqlTo("b")+","+sqlTo("&")+") and (Fkatesv=0 or Fkatesv is null)");
	ExecuteSQL("update ^lic_fld set Fkatesv=26 where Ffzp="+sqlTo("т")+" and (Fkatesv=0 or Fkatesv is null)");
	//добавление полей ЛС удержаний, начислений и баз ЕСВ
	var snap = getSnap("select Fwid from ^lic_fld where Fis8="+sqlTo("5"));
	var k = 0;
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("ЄСВ|ЕСВ");
			m.fis8 = "5";
			m.fis10 = "5";
			m.fis5 = "-";
			m.fis6 = "-";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis8="+sqlTo("6"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("ЄСВ з лікарн.|ЕСВ с больн.");
			m.fis8 = "6";
			m.fis10 = "6";
			m.fis5 = "-";
			m.fis6 = "-";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis8="+sqlTo("7"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("ЄСВ з тр.угоди|ЕСВ с тр.согл.");
			m.fis8 = "7";
			m.fis10 = "7";
			m.fis5 = "-";
			m.fis6 = "-";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select MAX(Ffld_num) from ^lic_fld where Fis12="+sqlTo("p"));
	if(snap)
		esvNum = Number(snap[0])+1;
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("0"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ на ЗП|нач.ЕСВ на ЗП");
			m.fis12 = "0";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("k"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ на тр.угоду|нач.ЕСВ на тр.согл.");
			m.fis12 = "k";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("h"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ на лікарн.|нач.ЕСВ на больн.");
			m.fis12 = "h";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("v"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ на витрати|нач.ЕСВ на затраты");
			m.fis12 = "v";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("w"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ з прибутку|нач.ЕСВ из прибыли");
			m.fis12 = "w";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("8"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ по комп.|нач.ЕСВ по комп.");
			m.fis12 = "8";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("9"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("нар.ЄСВ по чорн.лікв.|нач.ЕСВ по черн.ликв.");
			m.fis12 = "9";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("5"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("база ЄСВ|база ЕСВ");
			m.fis12 = "5";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("6"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("база ЄСВ лікарн.|база ЕСВ больн.");
			m.fis12 = "6";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	var snap = getSnap("select Fwid from ^lic_fld where Fis12="+sqlTo("7"));
	if(!snap)
	{
		var snap = getSnap("select MIN(Fid)+1 from ^lic_fld as l1 where not exists(select Fwid from ^lic_fld as l2 where l2.Fid=l1.Fid+1)")
		if(snap)
		{
			freeFid = snap[0];
			var m = new Object();
			m.fwid = GetUID();
			m.fid = freeFid;
			m.ffld_num = esvNum;
			m.ftxt = UR("база ЄСВ тр.угода|база ЕСВ тр.согл.");
			m.fis12 = "7";
			m.fis_slct = true;
			UpdateTable("^lic_fld", m, true);
			k++;
		}
	}
	//выполним перенумерацию полей ЛС
	DropTable("DOP_FLD");
	ExecuteSQL("SELECT Ffld_num,Ffld_num AS Fdopf,Fid,Fwid INTO DOP_FLD FROM ^LIC_FLD");
	ExecuteSQL("UPDATE dop_fld  SET Ffld_num= "
			+"(SELECT COUNT(*)+1 FROM ^LIC_FLD WHERE dop_fld.Ffld_num>Ffld_num "
			+" OR (dop_fld.Ffld_num=Ffld_num  AND dop_fld.Fwid>Fwid))");
	ExecuteSQL("UPDATE ^LIC_FLD " +
			"SET FFLD_NUM = (SELECT	MAX(FFLD_NUM) FROM DOP_FLD " +
			"WHERE ^LIC_FLD.FID = DOP_FLD.FID) " +
			"WHERE EXISTS (SELECT FFLD_NUM FROM DOP_FLD " +
			"WHERE ^LIC_FLD.FID = DOP_FLD.FID)");
	return k;
}

function getFwid_wpByTabnOnDate(tabn, date)
{
	var snap = getSnap("select MIN(Fwid) from ^full_pers where Fcodpers="+tabn+" and Fbdat<="+sqlTo(date)+" and Fedat>="+sqlTo(date));
	if(snap && snap[0])
		return snap[0];
	else
		return 0;
}

//процент из справочника ставок единого социального взноса (ЕСВ)
//type (тип):
//	'+' - процент начислений ЕСВ
//	'-' - процент удержаний ЕСВ
//vidnach (вид начислений в ЛС, можно не указывать, если передаем категорию застрахованных лиц):
//  'z' - основаня зарплата
//	'b' - больничные
//	't' - трудовое соглашение
//dat - дата на которую определяем ставку
//kzo (категория застрахованных лиц, если указан вид начислений, то КЗЛ достаточно указывать лишь для основной зарплаты 'z')
//	1 - основные сотрудники
//	2 - инвалиды
//	26 - по трудовому соглашению
//fwid_wp - идентификатор записи ШР, передаем если не известна КЗЛ, а вид начислений - основная зарплата 'z'
function getEsvProc(type,vidnach,dat,kzo,fwid_wp)
{
	var sFld;
	var sWhere = "1=1";
	switch(String(type))
	{
		case "+":
			sFld = "Fproc_n";
		break;
		case "-":
			sFld = "Fproc_u";
		break;
		default:
			WAIT(ru("Неизвестный параметр типа ","Невідомий параметр типу ")+type);
			return 0;
		break;
	}
	if(vidnach && String(vidnach).length==1)
		sWhere += " and Fvidnach="+sqlTo(String(vidnach));
	if(isDateType(dat))
		sWhere += " and Fbdat<="+sqlTo(dat)+" and Fedat>="+sqlTo(dat);
	else
	{
		WAIT(ru("Некорректное значение даты ","Некоректне значення дати ")+dat);
		return 0;
	}
	if(kzo)
		sWhere += " and Fcod_kzo="+kzo;
	if(fwid_wp)
		sWhere += " and Fcod_kzo=(select MAX(Fcod_kzo) from ^work_pers where Fwid="+fwid_wp+")";
	var snap = getSnap("select "+sFld+" from ^nalog_esv where "+sWhere);
	if(snap)
		return snap[0];
	else
		return 0;
}

function getsumsvzp(dat,flsid,ftabn_id,fvopl,fwid_org,subWhere,subFrom)
{
 return getSumSVZP(dat,flsid,ftabn_id,fvopl,fwid_org,subWhere,subFrom);
}
//расчет сум из лицевых счетов
// dat - дата, за месяц которой расчитываем
// flsid - код поля ЛС (можно массивом или строкой с разделением запятыми)
// ftabn_id - идентификтор сотрудника (можно массивом или строкой с разделением запятыми)
// fvopl - вид оплаты (можно массивом или строкой с разделением запятыми)
// fwid_org - идентификатор подразделения 
// subWhere - дополнительное SQL условие, где можно использовать алиас s (SVZP), l (LIC_FLD) и f (FULL_PERS)
// subFrom - SQL джоины дополнительных таблиц
function getSumSVZP(dat,flsid,ftabn_id,fvopl,fwid_org,subWhere,subFrom)
{
	var arrFwidOrgs = new Array();
	if (String(fwid_org).indexOf(",") == -1)
		arrFwidOrgs[0] = fwid_org;	
	else
	{
		arrFwidOrgs = String(fwid_org).split(",");
	}

	var summAll = 0;	
	for(var i=0; i<arrFwidOrgs.length; i++)
	{
		fwid_org = arrFwidOrgs[i];

		var szTag = getDateTag(dat);
		var sWhere = "NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(firstDayMonth(dat))+")";
		if(flsid)
			sWhere += " and s.Flsfid in ("+flsid+")";
		if(ftabn_id)
			sWhere += " and s.Ftabn_id in ("+ftabn_id+")";
		if(fvopl)
			sWhere += " and f.Fvopl in ("+fvopl+")";
		if(fwid_org)
		{
			var snap = getSnap("select Fleftkey, Frightkey from ^stru_org where Fwid="+fwid_org);
			if(snap)
				sWhere += " and f.Fleftkey>="+snap[0]+" and f.Frightkey<="+snap[1];
		}
		if(subWhere)
			sWhere += subWhere;
		var sFrom = "^svzp"+szTag+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid ";
		if(fvopl || fwid_org || (subWhere && subWhere.toLowerCase().indexOf(" f.")!=-1))
		{
			//джоиним только по последней должности в месяце расчета 
			sFrom += " inner join ^full_pers as f on f.Fwid_cl=s.Ftabn_id and ((f.Fbdat<="+sqlTo(lastDayMonth(dat))+" and f.Fedat>="+sqlTo(lastDayMonth(dat))+") "
					+" or (f.Fedat>="+sqlTo(firstDayMonth(dat))+" and f.Fedat<="+sqlTo(lastDayMonth(dat))
						+" and not exists(select Fwid from ^work_pers as w where w.Fwid_cl=f.Fwid_cl and w.Fbdat>f.Fedat and w.Fbdat<="+sqlTo(lastDayMonth(dat))+"))) "
		}
		if(subFrom)
			sFrom += subFrom;
		var snap = getSnap("select SUM(Fsum) from "+sFrom+" where "+sWhere);
		if(snap)
			summAll = summAll + Number(snap[0]);
	}
	
	return summAll;
}
//расчет сум из лицевых счетов за период
function getSumSVZPByPeriod(dat1,dat2,flsid,ftabn_id,fvopl,fwid_org,subWhere,subFrom)
{
	dat1 = firstDayMonth(dat1);
	dat2 = firstDayMonth(dat2);
	var d = new Date(dat1).getVarDate();
	var md = month_difference(new Date(dat1),new Date(dat2));
	var sum = 0;
	while(differ(d,dat2)<=0)
	{
		sum += getSumSVZP(d,flsid,ftabn_id,fvopl,fwid_org,subWhere,subFrom)
		d = goMonth(d, 1);
	}
	return sum;
}

//возвращает идентификатор ШР по идентификатору сотрудника и дате
function getFwid_wpOnDate(ftabn_id, dat)
{
	var snap = getSnap("select MIN(Fwid) from ^work_pers where Fwid_cl="+ftabn_id+" and Fbdat<="+sqlTo(dat)+" and Fedat>="+sqlTo(dat))
	if(snap && snap[0])
		return snap[0]
	else
		return 0;
}

//возвращает самый последний идентификатор ШР по идентификатору сотрудника
function getLastFwid_wpByID(ftabn_id)
{
	var snap = getSnap("select Fwid from ^work_pers as wp1 where Fwid_cl="+ftabn_id+" and Fid=(select MAX(Fid) from ^work_pers as wp2 where wp2.Fwid_cl=wp1.Fwid_cl)");
	if(snap && snap[0])
		return snap[0];
	else
		return 0;
}

//возвращает идентификатор ШР по табельному номеру
function getLastFwid_wpByTabn(ftabn)
{
	if(!getPar("CODPERS"))
		return 0;
	var ftabn_id = getIDFromCod(ftabn, getPar("CODPERS"));
	return getLastFwid_wpByID(ftabn_id);
}

//по коду приказа больничных согласно настройке упрощенных больничных возвращает соответствующие типы:
//	PR - за счет предприятия
//	SS - за счет соцстраха
//	BR - по беременности и родам (тоже относятся к соцстраху)
function getBlnType(fvid_prk)
{
	var type = "";
	var snap = getSnap("select Fvid_p, Fvid_s, Fis_berem from ^nast_bln where Fvid_p="+fvid_prk+" or Fvid_s="+fvid_prk);
	if(snap)
	{
		if(snap[2]==true)
			type = "BR";
		else if(snap[0]==fvid_prk)
			type = "PR";
		else
			type = "SS";
	}
	return type;
}

function getBlnNazv(cod)
{
	var oSnap = getSnap("select max(FNAZV) from ^NAST_BLN where FNOM = " + sqlTo(cod));
	if(!oSnap)
		return "???";
	
	return oSnap[0];
}

//возвращает название настройки отпуска по коду
function getOtpNameByFvid(fvid_prk)
{
	var snap = getSnap("select Fnazv, Fvid_n, Fvid_m from ^nast_otp where Fvid_n="+fvid_prk+" or Fvid_m="+fvid_prk);
	if(snap)
		return snap[0];
	else
		return "";
}

//функция возвращающая данные из ШР по табельному номеру на конкретную дату
//	tabn - таб.№ (обязательный параметр)
//	dat - дата на которую ищем запись в ШР
//	fld - поле из представления FULL_PERS (обязательный параметр)
//	subWhere - дополнительное условие
function getDataFromShtat(tabn, dat, fld, subWhere)
{
	var sWhere;
	if(tabn>0)
		sWhere = " Fcodpers="+tabn;
	else
		return null;
	if(isDateType(dat))
		sWhere += " and Fbdat<="+sqlTo(dat)+" and Fedat>="+sqlTo(dat);
	if(subWhere)
		sWhere += subWhere;
	var snap = getSnap("select "+fld+" from ^full_pers where "+sWhere, false);
	if(snap)
		return snap[0];
	else
		return null;
}

//создает и заполняет справочник видов начислений/удержаний расчетно-платежной ведомости, если такового нет, если в нем есть записи, то ничего не делаем
function addClRplatVed()
{
	//виды начислений
	//массив объектов со следущими полями:
	//	group - флаг принадлежности к группе
	//	txt - название
	//	where - SQL условие для перечня полей ЛС
	var nachAr = new Array(
					{group:true, txt:"Фонд основної заробітної плати"},
						{group:false, txt:"Тарифна ставка, посадовий оклад"},
						{group:false, txt:"Комісійні від реалізації продукції"},
						{group:false, txt:"Гонорар, авторська винагорода штатним працівникам"},
						{group:false, txt:"Оплата праці за час перебування у відрядженні", where:"Ffzp='к'"},
						{group:false, txt:"Оплата за профнавчання інших працівників"},
						{group:false, txt:"Вартість продукції, виданої працівникам при натуральній формі оплати праці"},
						{group:false, txt:"Інші види нарахувань", where:"Ffzp='+'"},
					{group:true, txt:"Фонд додаткової заробітної плати"},
						{group:false, txt:"Премія"},
						{group:false, txt:"Відсоткові або комісійні винагороди"},
						{group:false, txt:"Оплата роботи в надурочний час, святкові та неробочі дні"},
						{group:false, txt:"Оплата днів відпочинку"},
						{group:false, txt:"Індексація заробітної плати", where:"Fis7 in ('и','т')"},
						{group:false, txt:"Компенсації працівникам у зв'язку з порушенням термінів виплати заробітної плати"},
						{group:false, txt:"Витрати на безкоштовний проїзд"},
						{group:false, txt:"Вартість форменого одягу"},
						{group:false, txt:"Відпустка за поточний місяць",where:"Ffzp='о'"},
						{group:false, txt:"Відпустка за наступний період"},
						{group:false, txt:"Інші нарахування за невідпрацьований час (простої, медогляд та ін.)",where:"Ffzp='н'"},
						{group:false, txt:"Суміщення професій"},
						{group:false, txt:"Розширення зони обслуговування або збільшення обсягу робіт"},
						{group:false, txt:"Виконання обов'язків тимчасово відсутнього працівника"},
						{group:false, txt:"Робота у важких і шкідливих та особливо важких і особливо шкідливих умовах праці"},
						{group:false, txt:"Інтенсивність праці"},
						{group:false, txt:"Робота в нічний час"},
						{group:false, txt:"Керівництво бригадою"},
						{group:false, txt:"Висока професійна майстерність"},
						{group:false, txt:"Класність водіям транспортних засобів"},
						{group:false, txt:"Високі досягнення праці"},
						{group:false, txt:"Виконання особливо важливої роботи на певний термін"},
						{group:false, txt:"Знання та використання в роботі іноземної мови"},
						{group:false, txt:"Допуск до державної таємниці"},
						{group:false, txt:"Дипломатичні ранги, персональні звання службових осіб, ранги державних службовців, кваліфікаційні класи суддів"},
						{group:false, txt:"Науковий ступінь"},
						{group:false, txt:"Нормативний час пересування у шахті"},
						{group:false, txt:"Робота на територіях радіоактивного забруднення"},
						{group:false, txt:"Інші надбавки та доплати", where:"Ffzp='*'"},
						{group:false, txt:"Інші види нарахувань", where:"Ffzp='#'"},
					{group:true, txt:"Інші заохочувальні та компенсаційні виплати"},
						{group:false, txt:"Винагороди та заохочення, що мають одноразовий характер", where:"Fis4='v'"},
						{group:false, txt:"Матеріальна допомога, що має систематичний характер", where:"Ffzp='m'"},
						{group:false, txt:"Виплати соціального характеру"},
						{group:false, txt:"Інші заохочувальні та компенсаційні виплати"},
					{group:true, txt:"Інші виплати, що не належать до фонду оплати праці"},
						{group:false, txt:"Допомоги та інші виплати, що здійснюються за рахунок коштів фондів державного соціального страхування", where:"Ffzp in ('б','&')"},
						{group:false, txt:"Оплата перших 5 днів тимчасової непрацездатності за рахунок коштів підприємства", where:"Ffzp='b'"},
						{group:false, txt:"Дивіденди, відсотки, виплати за паями"},
						{group:false, txt:"Витрати на відрядження"},
						{group:false, txt:"Матеріальна допомога разового характеру"},
						{group:false, txt:"Внески підприємств на медичне та пенсійне страхування працівників"},
						{group:false, txt:"Інші види нарахувань"});
	//виды удержаний
	var udAr = new Array({group:false, txt:"Видано за I-у половину місяця (аванс)", where:"Fis10='а'"},
						{group:false, txt:"Єдиний соціальний внесок", where:"Fis8 in ('5','6','7')"},
						{group:false, txt:"Податок на доходи фізичних осіб", where:"Fis1 in ('п','s')"},
						{group:false, txt:"Профспілкові внески", where:"Fis1='ф'"},
						{group:false, txt:"Аліменти", where:"Fis5 in ('а','д')"},
						{group:false, txt:"Аванс в банк"},
						{group:false, txt:"Каса (належить до видачі)", where:"Fis10='т'"});
	var codCl = getPar("ZRP_RPLVED");
	var ok = true;
	var snap = getSnap("select Fwid from ^clcl where Fcod="+Number(codCl));
	if(codCl>0 && snap)
	{
		var snap = getSnap("select count(*) from ^clrelclcl where Fcl="+codCl);
		if(snap && snap[0]>0)
			return false;
	}
	else
	{
		include("Objects/DpClNo.js");
		var oN = new DpClNo("ADD", null, "clcl", "Fcod", null, null, null, true);
		codCl = oN.findFree();
		var m = new Object();
		m.FWID	= GetUID();
		m.FCOD = codCl;
		m.FTXT = "Види нарахувань/утримань розрахунково-платіжної відомості|Виды начислений/удержаний расчетно-платежной ведомости";
		m.FVID = "1";
		m.FSYSTEMS = "ZRP";
		m.FREL = 0;
		ok = UpdateTable("^clcl", m, true);
		if(ok)
			setPar("ZRP_RPLVED", codCl);
	}
	if(!ok)
		return false;
	//добавляем записи в справочник
//	var oCl = new DpClEx("CL1",codCl);
	var cod = mainParCod = 1;
	//группа начислений
	cod = 10;
	oCl = new DpClEx("CL1",codCl);
	oCl.setVar("HCOD",cod);
	oCl.setVar("HTXT","НАРАХУВАННЯ");
	oCl.setVar("HISGRP",true);
	//oCl.setVar("HGRPCOD",mainParCod);
	oCl.save();
	updateTreeKeys("^CLRELCLCL", oCl.getVar("HCOD"), "fcod", {extraWhere: " AND fcl=" + codCl, fwidField: "fcod"});
	var parGrCod = cod;
	var parCod = 0;
	for(var i=0; i<nachAr.length; i++)
	{
		oCl = new DpClEx("CL1",codCl);
		cod += 10;
		oCl.setVar("HCOD",cod);
		oCl.setVar("HTXT",nachAr[i].txt);
		oCl.setVar("HISGRP",nachAr[i].group);
		if(nachAr[i].group)
			parCod = cod;
		oCl.setVar("HGRPCOD",nachAr[i].group?parGrCod:parCod);
		oCl.save();
		updateTreeKeys("^CLRELCLCL", oCl.getVar("HCOD"), "fcod", {extraWhere: " AND fcl=" + codCl, fwidField: "fcod"});
	}
	//группа удержаний
	cod += 10;
	oCl = new DpClEx("CL1",codCl);
	oCl.setVar("HCOD",cod);
	oCl.setVar("HTXT","УТРИМАННЯ");
	oCl.setVar("HISGRP",true);
	//oCl.setVar("HGRPCOD",mainParCod);
	oCl.save();
	updateTreeKeys("^CLRELCLCL", oCl.getVar("HCOD"), "fcod", {extraWhere: " AND fcl=" + codCl, fwidField: "fcod"});
	var parGrCod = cod;
	parCod = cod;
	for(var i=0; i<udAr.length; i++)
	{
		oCl = new DpClEx("CL1",codCl);
		cod += 10;
		oCl.setVar("HCOD",cod);
		oCl.setVar("HTXT",udAr[i].txt);
		oCl.setVar("HISGRP",udAr[i].group);
		if(udAr[i].group)
			parCod = cod;
		oCl.setVar("HGRPCOD",udAr[i].group?parGrCod:parCod);
		oCl.save();
		updateTreeKeys("^CLRELCLCL", oCl.getVar("HCOD"), "fcod", {extraWhere: " AND fcl=" + codCl, fwidField: "fcod"});
	}
	//проставим для полей ЛС коды записей по соответствующим признакам
	var cod = 10;
	for(var i=0; i<nachAr.length; i++)
	{
		cod += 10;
		if(!nachAr[i].where)
			continue;
		var b = ExecuteSQL("update ^lic_fld set Frplatved="+cod+" where "+nachAr[i].where);
		if(!b)
			return false;
	}
	cod += 10;
	for(var i=0; i<udAr.length; i++)
	{
		cod += 10;
		if(!udAr[i].where)
			continue;
		var b = ExecuteSQL("update ^lic_fld set Frplatved="+cod+" where "+udAr[i].where);
		if(!b)
			return false;
	}
	return true;
}

function getFactTime(dat,ftabn_id,fwid_wp,isHours)
{
	var szTag = getDateTag(dat);
	var tbl = "^tbl"+szTag;
	var stt1 = "^stt1"+szTag;
	if(IsTableEx("ZRP_MDB","ZRP_STT1"+szTag))
	{
		var sWhere = " 1=1 ";
		if(ftabn_id)
			sWhere += " and st.Ftabn_id="+ftabn_id;
		if(fwid_wp)
			sWhere += " and st.Fwid_wp="+fwid_wp;
		if(sWhere == " 1=1 ")
		{
			WAIT("Недостаточно параметров в ф-ие getFactTime()!");
			return 0;
		}
		var t = OpenTable("select st.*, ti.fnorma_ch, ti.fnorma_d, t.fchasnvk, t.fday_nvk from "+stt1+" as st "
					+" inner join ^work_pers as wp on wp.Fwid=st.Fwid_wp "
					+" inner join ^tbl_ini as ti on ti.fvopl=wp.fvopl and ti.fbdat=" + sqlTo(firstDayMonth(dat))
					+" left join "+tbl+" as t on t.Fwid_wp=st.Fwid_wp and t.Fkod_nvk=2"
				+" where "+sWhere);
		if(t.getValue("Fis_tabel")=="*")
		{
			if(isHours)
				return Number(t.getValue("fnorma_ch"));
			else
				return Number(t.getValue("fnorma_d"));
		}
		if(t.getValue("Fis_tabel")!="+")
			return 0;
		var time = 0;
		for(; !t.IsEOF(); t.MoveNext())
		{
			if(isHours)
				time += Number(t.getValue("fchasnvk"));
			else
				time += Number(t.getValue("fday_nvk"));
		}
		t.close();
		return time;
	}
	else
		return 0;
}

function getTxtKatPersTbl5(cod)
{
	switch(Number(cod))
	{
		case 1:
			return UR("Наймані працівники (трудова книжка)|Наемные работники (трудовая книжка)");
		case 2:
			return UR("Наймані працівники (без трудової книжки)|Наемные работники (без трудовой книжки)");
		case 3:
			return UR("Особи, які виконують роботу за трудовим договором|Лица, выполняющие работу по трудовому договору");
		case 4:
			return UR("Особи, яким надано відпустку по догляду за дитиною до 6 років|Лица, которым предоставлен отпуск по уходу за ребенком до 6 лет");
		case 5:
			return UR("Особи, яким надано відпустку по вагітності і пологам|Лица, которым предоставлен отпуск по беременности и родам");
		default:
			return "";
	}
}

//проставляет календарные дни больничных и рабочие дни отпускных в приказах и лицевых счетах
function prepairBlnOtpDays()
{
	//в отпускных рабочие дни проставлялись и раньше в поле FPROC
	ExecuteSQL("update ^prk_all set Fdnkl=Fproc where Fin_table="+sqlTo("PRK_O")+" and Fdnkl=0");
	//в больничных календарные дни проставляем как разность периода
	ExecuteSQL("update ^prk_all set Fdnkl="+SqlDaysBWDates("Fbdat","Fedat")+"+1 where Fin_table="+sqlTo("PRK_B")+" and Fedat<>"+sqlTo(d00)+" and Fdnkl=0");
	var D1 = new Date(2010,0,1).getVarDate();
	var D2 = firstDayMonth(today);
	var d = new Date(D1).getVarDate();
	var md = month_difference(new Date(D1),new Date(D2));
	var step = 1;
	var tblCount = 0;
	//setProgressRange(step, md);	//валится при модификации базы
	while(differ(d,D2)<=0)
	{
		tblName = "SVZP"+getDateTag(d);
		//setProgressPos(step++, ru("Проставление дней больничных и отпускных в лицевых счетах за ",
		//						"Проставлення днів лікарняних і відпускних в особових рахунках за ")+format("mm/yyyy",d));
		if(IsTableEx("ZRP_RES", "ZRP_"+tblName))
		{
			tblName = "^"+tblName;
			ExecuteSQL("UPDATE "+tblName
						+" SET Fdnkl = (SELECT Fdnkl FROM ^prk_all as p WHERE "+tblName+".Fid_prk=p.Fwid and p.Fdnkl>0)"
						+" WHERE EXISTS (SELECT * FROM ^prk_all as p WHERE "+tblName+".Fid_prk=p.Fwid and p.Fdnkl>0) and Fdnkl=0");
			tblCount++;
		}
		d = goMonth(d, 1);
	}
	//setProgressPos(0);
}
